﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using Geometry.GGraphic.Forms.Detail.FormatString;
using Geometry.GraphicObjects;
using Geometry.GGraphic.Forms.Detail;

namespace Geometry.GGraphic.Controls.ElementaryControls
{
    public partial class CustomToolTip : ToolTip
    {
        public const int DistanceFromContents = 12;
        private Graphics _graphics;
        IEquationGR _equationGR;

        private struct CustomToolTipPair
        {
            public EquationLineControl EquationViewLine;
            public Rectangle bounds;
            public CustomToolTipPair(EquationLineControl EquationViewLineArg, Rectangle boundsArg)
            {
                EquationViewLine = EquationViewLineArg;
                bounds = boundsArg;
            }
        }


        public CustomToolTip()
        {
            _graphics = new PictureBox().CreateGraphics();
            this.InitialDelay = 100;
            this.ReshowDelay = 100;
            this.AutoPopDelay = 10000;
            this.OwnerDraw = true;
            this.Popup += new PopupEventHandler(this.OnPopup);
            this.Draw += new DrawToolTipEventHandler(this.OnDraw);
        }

        public void SetContents(IEquationGR equationGR)
        {
            _equationGR = equationGR;
        }


        private void OnPopup(object sender, PopupEventArgs e) // use this event to set the size of the tool tip
        {
            e.ToolTipSize = new Size(_equationGR.DynamicWidth + 24, _equationGR.DynamicHeight + 24);
        }

        private void OnDraw(object sender, DrawToolTipEventArgs e)
        {
            Graphics g = e.Graphics;
            Brush brush = Brushes.Black;
            Brush backgroud = SystemBrushes.Info;
            Pen pen = new Pen(brush);
            g.FillRectangle(backgroud, e.Bounds);
            g.DrawRectangle(new Pen(Brushes.Black, 1), new Rectangle(e.Bounds.X, e.Bounds.Y,
                e.Bounds.Width - 1, e.Bounds.Height - 1));

            _equationGR.DrawToToolTip(g);
        }
    }
}
