﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace Geometry.GGraphic.Controls.ElementaryControls
{
    public partial class DrawingPanel : Panel
    {

        /// <summary>
        /// Scéna, jejíž obsah je vykreslován v daném DrawingPanelu.
        /// </summary>
        protected Scene _scene;

        public bool DrawDisabled
        {
            get;
            set;
        }

        public DrawingPanel()
        {
            InitializeComponent();
            DrawDisabled = false;
            this.BackColor = SystemColors.ActiveCaption;
            this.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
        }

        public DrawingPanel(IContainer container)
        {
            container.Add(this);

            InitializeComponent();
            DrawDisabled = false;
            this.BackColor = SystemColors.ActiveCaption;
            this.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
        }

        public void SetScene(Scene scene) { _scene = scene; }

        protected override void OnPaint(PaintEventArgs e)
        {
             RenderScene();
        }
        protected override void OnPaintBackground(PaintEventArgs e)
        {
            if (_scene == null)
                base.OnPaintBackground(e);
        }

        public void RenderScene()
        {
            if (_scene != null && !DrawDisabled)
                _scene.RenderScene();
        }
    }
}
