﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Geometry.GGraphic.Controls.ElementaryControls
{
    public partial class NameTextBox : TextBox
    {
        private int MaxNameLength = Configuration.MaximalNameLength;

        public NameTextBox()
        {
            InitializeComponent();
        }

        public NameTextBox(IContainer container)
        {
            container.Add(this);

            InitializeComponent();
        }

        private void NameTextBox_TextChanged(object sender, EventArgs e)
        {
            if (this.Text.Length <= MaxNameLength)
            {
                return;
            }
            else
            {
                ShowWarning("Zadané jméno je příliš dlouhé. Maximální povolená délka je "
                    + MaxNameLength.ToString() + " znaků.");
                this.Text = this.Text.Substring(0, MaxNameLength);
                this.SelectionStart = this.Text.Length;
                return;
            }
        }

        public void ShowWarning(string text) 
        {
            MessageBox.Show(
                text,
                "Upozornění",
                MessageBoxButtons.OK,
                MessageBoxIcon.Warning);
        }
    }
}
