﻿using System;
using Geometry.GraphicObjects.Equations;
using GMath;

namespace Geometry.GGraphic.Forms.Detail.FormatString
{
    /// <summary>
    /// Předpis kanonické rovnice
    /// </summary>
    public class CanonicEquationFormatString:IFormatString
    {
        private string _equationInitialFormatString;
        private string _equationSubstitutedFormatString;
        private string _equationGeneralFormatString;

        public CanonicEquationFormatString(string equationInitialFormatString) 
        {
            _equationInitialFormatString = equationInitialFormatString;
            _equationGeneralFormatString = base.IgnoreSpecialCharacters(equationInitialFormatString);
        }


        public void SubstituteToFormatString(ParametricEquation parametricEquation, CenterParametrization center)
        {
            _equationSubstitutedFormatString = SubstituteToFormatString(_equationInitialFormatString, parametricEquation, center);
        }


         // vykricnik znamena substituci
        protected string SubstituteToFormatString
            (string expression, ParametricEquation canonicEquation, CenterParametrization center)
        {
            string retval = "";
            double temp = 0;
            for (int i = 0; i < expression.Length; i++)
            {
                if (expression[i] == '!')
                {
                    switch (expression[++i])
                    {
                        case 'a': temp = canonicEquation.GetA(); break;
                        case 'b': temp = canonicEquation.GetB(); break;
                        case 'c': temp = canonicEquation.GetC(); break;
                        case 'p': temp = canonicEquation.GetP(); break;
                        case 'm': temp = center.GetX().GetConstant(); break;
                        case 'n': temp = center.GetY().GetConstant(); break;
                        case 'o': temp = center.GetZ().GetConstant(); break;
                        //case 'u': temp = GetU(expression[++i], canonicEquation); break;
                        //case 'v': temp = GetV(expression[++i], canonicEquation); break;                   
                        default: throw new Exception("Je pozadovana substituce za neznamy znak.");
                    }
                    retval += Program.GetOutputFormatedForCleverLabel(temp);
                }else retval += expression[i];
            }
            return retval;
        }

        //private double GetU(char index, ParametricEquation canonicEquation) 
        //{
        //    switch (index) 
        //    {
        //        case Unicode.Index1Char: return canonicEquation.GetUx();
        //        case Unicode.Index2Char: return canonicEquation.GetUy();
        //        case Unicode.Index3Char: return canonicEquation.GetUz();
        //        default: throw new Exception("Je pozadovana substituce za neznamou sekvenci znaků.");
        //    }
        //}

        //private double GetV(char index, ParametricEquation canonicEquation)
        //{
        //    switch (index)
        //    {
        //        case Unicode.Index1Char: return canonicEquation.GetVx();
        //        case Unicode.Index2Char: return canonicEquation.GetVy();
        //        case Unicode.Index3Char: return canonicEquation.GetVz();
        //        default: throw new Exception("Je pozadovana substituce za neznamou sekvenci znaků.");
        //    }
        //}




        public string GetSubstitutedFormatString() { return _equationSubstitutedFormatString; }

        public string GetGeneralFormatString() { return _equationGeneralFormatString; }
    }
}
