﻿using GMath;

namespace Geometry.GGraphic.Forms.Detail.FormatString
{
    public class CenterFormatString:IFormatString
    {
        
        private string _xEquationGeneralFormatString;
        private string _yEquationGeneralFormatString;
        private string _zEquationGeneralFormatString;

        private string _xEquationSubstitutedFormatString;
        private string _yEquationSubstitutedFormatString;
        private string _zEquationSubstitutedFormatString;


        public CenterFormatString(CenterParametrization center) 
        {
            _xEquationGeneralFormatString = "L[x = m]";
            _yEquationGeneralFormatString = "L[y = n]";
            _zEquationGeneralFormatString = "L[z = o]";

            string x = Program.GetOutputFormatedForCleverLabel(center.GetX().GetConstant());
            string y = Program.GetOutputFormatedForCleverLabel(center.GetY().GetConstant());
            string z = Program.GetOutputFormatedForCleverLabel(center.GetZ().GetConstant());    

            _xEquationSubstitutedFormatString = "L[x = " + x + "]";
            _yEquationSubstitutedFormatString = "L[y = " + y + "]";
            _zEquationSubstitutedFormatString = "L[z = " + z + "]";        
        }

        public string GetXGeneralFormatString() { return _xEquationGeneralFormatString; }
        public string GetYGeneralFormatString() { return _yEquationGeneralFormatString; }
        public string GetZGeneralFormatString() { return _zEquationGeneralFormatString; }

        public string GetXSubstitutedFormatString() { return _xEquationSubstitutedFormatString; }
        public string GetYSubstitutedFormatString() { return _yEquationSubstitutedFormatString; }
        public string GetZSubstitutedFormatString() { return _zEquationSubstitutedFormatString; }
    }
}
