﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects;
using Geometry.GraphicObjects.Equations;

namespace Geometry.GGraphic.Forms.Detail.FormatString
{
    public class CommonEquationFormatString:IFormatString
    {
        private string _equationInitialFormatString;
        private string _equationGeneralFormatString;
        private string _equationSubstitutedFormatString;


        public CommonEquationFormatString(CommonEquationFormatString commonEquationFormatString) 
        {
            this._equationGeneralFormatString = commonEquationFormatString._equationGeneralFormatString;
            this._equationInitialFormatString = commonEquationFormatString._equationInitialFormatString;
            this._equationSubstitutedFormatString = commonEquationFormatString._equationSubstitutedFormatString;
        }
        public CommonEquationFormatString(string equationInitialFormatString) 
        {
            _equationInitialFormatString = equationInitialFormatString;
            _equationGeneralFormatString = base.IgnoreSpecialCharacters(equationInitialFormatString);
        }




        public void SubstituteToFormatString(CommonEquation commonEquation) 
        {
            _equationSubstitutedFormatString = SubstituteToFormatString(_equationInitialFormatString, commonEquation);
        }
        protected string SubstituteToFormatString(string expression, CommonEquation commonEquation)
        {
            string retval = "";
            double value = 0;
            for (int i = 0; i < expression.Length; i++)
            {
                if (expression[i] == '!')
                {
                    value = GetCommonSubstitution(expression[++i], commonEquation);
                    retval += Program.GetOutputFormatedForCleverLabel(value);
                }
                else { retval += expression[i]; }
            }
            if (retval.Length <= 3)
                retval = "0 = 0";
            return retval;
        }


        protected double GetCommonSubstitution(char ch, CommonEquation commonEquation) 
        {
            switch (ch)
            {
                case 'A': return commonEquation.GetA();
                case 'B': return commonEquation.GetB();
                case 'C': return commonEquation.GetC();
                case 'D': return commonEquation.GetD();
                case 'E': return commonEquation.GetE();
                case 'F': return commonEquation.GetF();
                case 'G': return commonEquation.GetG();
                case 'H': return commonEquation.GetH();
                case 'K': return commonEquation.GetK();
                case 'L': return commonEquation.GetL();
                default: throw new Exception("Je pozadovana substituce za neznamy znak.");
            }  
        }


        public string GetGeneralFormatString() { return _equationGeneralFormatString; }
        public string GetSubstitutedFormatString() { return _equationSubstitutedFormatString; }
    }
}
