﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects;
using System.Drawing;
using Geometry.GGraphic.Forms.Detail;

namespace Geometry.GGraphic.Controls
{
    public partial class CanonicEquationGR : IEquationGR
    {
        private EquationLineControl _canonicEquationView;

        public CanonicEquationGR()
            : base()
        {
            SuspendLayout();
            _canonicEquationView = new EquationLineControl();
            _canonicEquationView.FakeLocation = new Point(0, 0);
            this.Controls.Add(_canonicEquationView);
            ResumeLayout();
        }

        public override void SetContents(GraphicObject graphicObject, string canonicFormatString)
        {
            _canonicEquationView.SetContents(graphicObject, canonicFormatString);
            this.DynamicWidth = _canonicEquationView.FakeLocation.X + _canonicEquationView.FakeWidth;
            this.DynamicHeight = _canonicEquationView.FakeLocation.Y + _canonicEquationView.FakeHeight;
        }

        public override void SetRealDynamicSize()
        {
            base.SetRealDynamicSize();
            _canonicEquationView.SetSize();
        }

        /// <summary>
        /// Používat jen pro toolTipy, protože kreslení jednotlivých řádek můžu provádět ve formu zvlášť.
        /// </summary>
        /// <param name="g"></param>
        public override void DrawToToolTip(Graphics g)
        {
            _canonicEquationView.DrawToToolTip(g);
        }
    }
}
