﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using Geometry.GGraphic.Forms.Detail.Layout;
using Geometry.GraphicObjects;
using Geometry.GGraphic.Controls.ElementaryControls;

namespace Geometry.GGraphic.Controls
{
    public partial class CenterGR : IEquationGR
    {
        private Label _xEquationView;
        private Label _yEquationView;
        private Label _zEquationView;

        public CenterGR()
            : base()
        {
            SuspendLayout();
            _xEquationView = new Label();
            _yEquationView = new Label();
            _zEquationView = new Label();
            _xEquationView.Text = "x = - 8.888E+888";
            _yEquationView.Text = "y = - 8.888E+888"; // kvuli autosize
            _zEquationView.Text = "z = - 8.888E+888";
            _xEquationView.AutoSize = true;
            _yEquationView.AutoSize = true;
            _zEquationView.AutoSize = true;
            _xEquationView.Location = new Point(0, 0);
            _yEquationView.Location = new Point(0, _xEquationView.Location.Y + _xEquationView.PreferredHeight + LayoutProperties.TextTopSpace);
            _zEquationView.Location = new Point(0, _yEquationView.Location.Y + _yEquationView.PreferredHeight + LayoutProperties.TextTopSpace);
            this.Controls.Add(_xEquationView);
            this.Controls.Add(_yEquationView);
            this.Controls.Add(_zEquationView);

            int height = _zEquationView.Location.Y + _zEquationView.Height;
            int width = Math.Max(Math.Max(_xEquationView.Width, _yEquationView.Width), _zEquationView.Width);
            this.Height = height;
            this.Width = width + _xEquationView.Location.X;

            this.DynamicHeight = height;
            this.DynamicWidth = width;
            ResumeLayout();
        }

        /// <summary>
        /// Kvuli tomu, že je velikost tohoto prvku konstantní a preventivně obvykle větší než je potřeba,
        /// není potom v Editaci středu, náhled obecné rovnice uprostřed okna ale, víc nalevo.
        /// </summary>
        public CenterGR(bool generalViewInEditCenter) 
        {
            SuspendLayout();
            _xEquationView = new Label();
            _yEquationView = new Label();
            _zEquationView = new Label();
            _xEquationView.Text = "x = m";
            _yEquationView.Text = "y = n"; // kvuli autosize
            _zEquationView.Text = "z = o";
            _xEquationView.AutoSize = true;
            _yEquationView.AutoSize = true;
            _zEquationView.AutoSize = true;
            _xEquationView.Location = new Point(0, 0);
            _yEquationView.Location = new Point(0, _xEquationView.Location.Y + _xEquationView.PreferredHeight + LayoutProperties.TextTopSpace);
            _zEquationView.Location = new Point(0, _yEquationView.Location.Y + _yEquationView.PreferredHeight + LayoutProperties.TextTopSpace);
            this.Controls.Add(_xEquationView);
            this.Controls.Add(_yEquationView);
            this.Controls.Add(_zEquationView);

            int height = _zEquationView.Location.Y + _zEquationView.Height;
            int width = Math.Max(Math.Max(_xEquationView.Width, _yEquationView.Width), _zEquationView.Width);
            this.Height = height;
            this.Width = width + _xEquationView.Location.X;

            this.DynamicHeight = height;
            this.DynamicWidth = width;
            ResumeLayout();
        }

        public override void SetContents(GraphicObject graphicObject, string centerXFormatString,
            string centerYFormatString, string centerZFormatString)
        {
            SuspendLayout();
            string xString = centerXFormatString.Substring(2, centerXFormatString.Length - 3);
            string yString = centerYFormatString.Substring(2, centerYFormatString.Length - 3);
            string zString = centerZFormatString.Substring(2, centerZFormatString.Length - 3);

            _xEquationView.Text = centerXFormatString.Substring(2, centerXFormatString.Length - 3);
            _yEquationView.Text = centerYFormatString.Substring(2, centerYFormatString.Length - 3);
            _zEquationView.Text = centerZFormatString.Substring(2, centerZFormatString.Length - 3);
            ResumeLayout();
        }

        public override void SetRealDynamicSize() { }
    }
}
