﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Drawing;
using Geometry.GraphicObjects;
using Geometry.GGraphic.Forms.Detail;

namespace Geometry.GGraphic.Controls
{
    public partial class CommonEquationGR : IEquationGR
    {
        private EquationLineControl _commonEquationView;

        public CommonEquationGR()
            : base()
        {
            _commonEquationView = new EquationLineControl();
            _commonEquationView.FakeLocation = new Point(0, 0);
            this.Controls.Add(_commonEquationView);
        }

        public override void SetContents(GraphicObject graphicObject, string commonFormatString)
        {
            _commonEquationView.SetContents(graphicObject, commonFormatString);
            this.DynamicWidth = _commonEquationView.FakeLocation.X + _commonEquationView.FakeWidth;
            this.DynamicHeight = _commonEquationView.FakeLocation.Y + _commonEquationView.FakeHeight;
        }

        public override void SetRealDynamicSize()
        {
            base.SetRealDynamicSize();
            _commonEquationView.SetSize();
        }


        /// <summary>
        /// Používat jen pro toolTipy, protože kreslení jednotlivých řádek můžu provádět ve formu zvlášť.
        /// </summary>
        /// <param name="g"></param>
        public override void DrawToToolTip(Graphics g)
        {
            _commonEquationView.DrawToToolTip(g);
        }
    }
}
