﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Drawing;
using Geometry.GraphicObjects;
using Geometry.GGraphic.Forms.Detail;

namespace Geometry.GGraphic.Controls
{
    public partial class ParametricEquationsGR : IEquationGR
    {
        private EquationLineControl _xEquationView;
        private EquationLineControl _yEquationView;
        private EquationLineControl _zEquationView;

        public ParametricEquationsGR()
            : base()
        {
            _xEquationView = new EquationLineControl();
            _yEquationView = new EquationLineControl();
            _zEquationView = new EquationLineControl();
            SuspendLayout();
            this.Controls.Add(_xEquationView);
            this.Controls.Add(_yEquationView);
            this.Controls.Add(_zEquationView);
            ResumeLayout();
        }

        public override void SetContents(GraphicObject graphicObject, string parametricXFormatString,
            string parametricYFormatString, string parametricZFormatString)
        {
            _xEquationView.SetContents(graphicObject, parametricXFormatString);
            _yEquationView.SetContents(graphicObject, parametricYFormatString);
            _zEquationView.SetContents(graphicObject, parametricZFormatString);
            _xEquationView.FakeLocation = new Point(0, 0);
            _yEquationView.FakeLocation = new Point(0, _xEquationView.FakeLocation.Y + _xEquationView.FakeHeight);
            _zEquationView.FakeLocation = new Point(0, _yEquationView.FakeLocation.Y + _yEquationView.FakeHeight);
            this.DynamicHeight = _zEquationView.FakeLocation.Y + _zEquationView.FakeHeight;
            int width = Math.Max(Math.Max(_xEquationView.FakeWidth, _yEquationView.FakeWidth), _zEquationView.FakeWidth);
            int location = Math.Max(Math.Max(_xEquationView.FakeLocation.X, _yEquationView.FakeLocation.X),
                _zEquationView.FakeLocation.X);
            this.DynamicWidth = location + width;
        }

        public override void SetRealDynamicSize()
        {
            base.SetRealDynamicSize();
            _xEquationView.SetSize();
            _yEquationView.SetSize();
            _zEquationView.SetSize();
        }


        /// <summary>
        /// Používat jen pro toolTipy, protože kreslení jednotlivých řádek můžu provádět ve formu zvlášť.
        /// </summary>
        /// <param name="g"></param>
        public override void DrawToToolTip(Graphics g)
        {
            _xEquationView.DrawToToolTip(g);
            _yEquationView.DrawToToolTip(g);
            _zEquationView.DrawToToolTip(g);
        }
    }
}
