﻿using System.Windows.Forms;
using Geometry.GraphicObjects.Intersections;
using Geometry.GGraphic.Forms.Detail.FormatString;
using System.Drawing;
using Geometry.GGraphic.Controls;

namespace Geometry.GGraphic.Controls.IntersectionControls
{

    /// <summary>
    /// Vytvori prvek nesouci parametrizaci.
    /// 
    /// Pokud je simple ruled kvadrika cokoliv jineho nez hyperbolicka valcova plocha,
    /// pak pouze k textu (x =) pridam parametrizaci konvertovanou na text.
    /// 
    /// Pokud je simple ruled kvadrika hyperbolicka valcova plocha,
    /// pak pridam k (x =) konstantu, kterou je nasobena odmocnina a pridam odmocninovy clen.
    /// Ostatni cleny parametrizace vzniknou jako v jednodussim pripade.
    /// Nakonec dojde na preskladani prvku.
    /// </summary>
    public partial class IntersectionParametrizationControl : ParametricEquationsGR
    {


        public IntersectionParametrizationControl()
        {
        }


        public void SetContents(CurveAsQuadricsIntersection section)
        {
            ParametrizationVector parametrizationVector = section.GetParametrizationVectorInStadardBasis();
            string xValue = parametrizationVector.GetXParametrization().ToFormatString();
            string yValue = parametrizationVector.GetYParametrization().ToFormatString();
            string zValue = parametrizationVector.GetZParametrization().ToFormatString();
            if (xValue == "L[]" || xValue == "L[ ]") xValue = "L[0]";
            if (yValue == "L[]" || yValue == "L[ ]") yValue = "L[0]";
            if (zValue == "L[]" || zValue == "L[ ]") zValue = "L[0]";
            string xString = "L[x=]" + xValue;
            string yString = "L[y=]" + yValue;
            string zString = "L[z=]" + zValue;

            base.SetContents(section, xString, yString, zString);
        }
    }
}
