﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Forms;

namespace Geometry.GGraphic.Forms.Detail
{
    public partial class FracControl : MemberControl
    {
        /// <summary>
        /// čitatel
        /// </summary>
        private MemberControl _numerator;
        /// <summary>
        /// jmenovatel
        /// </summary>
        private MemberControl _denominator;


        private static Color _fracLineBackColor = Color.Black;


        /// <summary>
        /// Nepouzivat, existuje jen pro eliminaci warningu 
        /// </summary>
        public FracControl() 
        {
        }

        public FracControl(MemberControl numeratorControl, MemberControl denominatorControl) 
        {          
            SetContents(numeratorControl, denominatorControl);
        }


        /// <summary>
        /// Vytvorí obecny clen (x-m)^2/a*a
        /// 
        /// </summary>
        /// <param name="x"> [x,y,z] </param>
        public void SetContents(MemberControl numerator, MemberControl denominator) 
        {
            _numerator = numerator;
            _denominator = denominator;

            int max = Math.Max(_numerator.DynamicWidth, _denominator.DynamicWidth);
            _numerator.DynamicLocation = new Point((max - _numerator.DynamicWidth) / 2, 0);
            _denominator.DynamicLocation = new Point((max - _denominator.DynamicWidth) / 2, _numerator.DynamicHeight-2);
            this.DynamicWidth = max;
            this.DynamicHeight = _denominator.DynamicLocation.Y + _denominator.DynamicHeight;
        }

        public override Size Draw(Graphics g, Point parentLocation)
        {
            Brush brush = Brushes.Black;

            _numerator.Draw(g, new Point(parentLocation.X + DynamicLocation.X, parentLocation.Y + DynamicLocation.Y));
            _denominator.Draw(g, new Point(parentLocation.X + DynamicLocation.X, parentLocation.Y + DynamicLocation.Y)); 
            g.DrawLine(new Pen(brush),
                new PointF(parentLocation.X + DynamicLocation.X, parentLocation.Y + DynamicLocation.Y + _numerator.DynamicHeight -3),
                new PointF(parentLocation.X + DynamicLocation.X + DynamicWidth, parentLocation.Y + DynamicLocation.Y + _numerator.DynamicHeight-3)); // cara dlouha jako citatel

            return new Size(DynamicWidth, DynamicHeight);
        }
    }
}
