﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using Geometry.GGraphic.Controls.ElementaryControls;

namespace Geometry.GGraphic.Forms.Detail
{
    class LabelControl : MemberControl
    {
        private static CleverLabel _label = new CleverLabel();
        private static Graphics _g = new Label().CreateGraphics();
        private Font _font;
        private string _text;

        public LabelControl(string text)
        {
            SetContents(text);
        }

        public void SetContents(string text)
        {
            _label.Text = text;
            this._text = _label.Text;
            this._font = _label.Font;
            SizeF size = _g.MeasureString(_text, _font);
            this.DynamicWidth = (int)Math.Ceiling(size.Width);
            this.DynamicHeight = (int)Math.Ceiling(size.Height);
        }

        public override Size Draw(Graphics g, Point parentLocation)
        {
            Brush brush = Brushes.Black;
            //Brush temp = Brushes.AliceBlue;
            //g.FillRectangle(temp, parentLocation.X + FakeLocation.X, parentLocation.Y + FakeLocation.Y, FakeWidth, FakeHeight);
            g.DrawString(_text, _font, brush, new Point(parentLocation.X + DynamicLocation.X, parentLocation.Y + DynamicLocation.Y));
            return new Size(DynamicWidth, DynamicHeight);
        }
    }
}
