﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Windows.Forms; 

using Geometry.GGraphic.Forms.Detail.Layout;
using System.Drawing;
using Geometry.GGraphic.Controls.TabPages; 

namespace Geometry.GGraphic.Forms.Detail.Controls
{
    public partial class CheckBoxesComponent : Control
    {
        DrawableTabPage _drawableTabPage;  

        public CheckBoxesComponent(DrawableTabPage drawableTabPage)
        {
            _drawableTabPage = drawableTabPage;
            InitializeComponent();
            this.Controls.Add(checkBoxHide);
            this.Controls.Add(checkBoxShowAxes);
            PerformCustomLayout();
        }

        public void GenerateContents(bool hideObject, bool showAxes) 
        {
            checkBoxHide.CheckedChanged -= new EventHandler(checkBoxHide_CheckedChanged);
            checkBoxShowAxes.CheckedChanged -= new EventHandler(checkBoxShowAxes_CheckedChanged);
            checkBoxHide.Checked = hideObject;
            checkBoxShowAxes.Checked = showAxes;
            checkBoxHide.CheckedChanged += new EventHandler(checkBoxHide_CheckedChanged);
            checkBoxShowAxes.CheckedChanged += new EventHandler(checkBoxShowAxes_CheckedChanged);
        }

        private void PerformCustomLayout() 
        {
            checkBoxHide.Location = new Point(0, 0);
            checkBoxShowAxes.Location = new Point(0, 
                checkBoxHide.Location.Y + checkBoxHide.PreferredSize.Height + LayoutProperties.TextTopSpace);
            this.Width = Math.Max(checkBoxHide.PreferredSize.Width, checkBoxShowAxes.PreferredSize.Width);
            this.Height = checkBoxShowAxes.Location.Y + checkBoxShowAxes.PreferredSize.Height;
        }

        private void checkBoxHide_CheckedChanged(object sender, EventArgs e)
        {
            _drawableTabPage.HideObjectChanged(checkBoxHide.Checked);
        }

        private void checkBoxShowAxes_CheckedChanged(object sender, EventArgs e)
        {
            _drawableTabPage.ShowAxesChanged(checkBoxShowAxes.Checked);
        }

        public void DisableObjectsAxesCheckBox()
        {
            checkBoxShowAxes.Enabled = false;
        }
    }
}
