﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Geometry.GraphicObjects.Equations;
using Geometry.GGraphic.Forms.Detail.Layout; 

namespace Geometry.GGraphic.Forms.Detail.Controls
{
    public partial class IKoeficientsControl : UserControl
    {
        public IKoeficientsControl()
        {
            InitializeComponent();
            this.CausesValidation = false;
        }

        public void SetLocation(int x, int y)
        {
            this.Location = new Point(x, y);
        }

        public void SetCenterLayoutWidth(int width)
        {
            int x = (int)((width - this.Width) / 2) + LayoutProperties.WindowSideSpace;
            this.Location = new Point(x, this.Location.Y);
        }

        public void ShowWarningMessage(string text)
        {
            MessageBox.Show(text, "Upozornění", MessageBoxButtons.OK, MessageBoxIcon.Warning);
        }

        public void ShowBadInputFormatWarningMessage(string errorKoef) 
        {
            ShowWarningMessage("Zadaná hodnota koeficientu " + errorKoef + " není požadovaného typu. \n"
                                + "Desetinná čísla pište s čárkou.");
        }


    }
}