﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects.Equations;
using Geometry.GGraphic.Forms.Detail.Layout;
using Geometry.BaseClasses; 

namespace Geometry.GGraphic.Forms.Detail.Controls
{
    public class KoefsAndCenterControl:IKoeficientsControl
    {
        private IParametricKoeficientsControl superParametricKoeficientsControl;
        private CenterKoeficientsControl centerKoeficientsControl;
        
        public KoefsAndCenterControl() 
        {
            InitializeComponent();
        }

        public KoefsAndCenterControl(IParametricKoeficientsControl parametricKoeficientsControl,
            CenterKoeficientsControl centerKoeficientsControl) 
        {
            InitializeComponent(parametricKoeficientsControl, centerKoeficientsControl);
            centerKoeficientsControl.TabIndex = 0;
            parametricKoeficientsControl.TabIndex = 1;
        }

        private void InitializeComponent(IParametricKoeficientsControl parametricKoeficientsControl,
            CenterKoeficientsControl centerKoeficientsControl)
        {
            this.superParametricKoeficientsControl = parametricKoeficientsControl;
            this.centerKoeficientsControl = centerKoeficientsControl;
            this.Controls.Add(superParametricKoeficientsControl);
            this.Controls.Add(centerKoeficientsControl);
            // 
            // centerKoeficientsControl1
            // 
            this.centerKoeficientsControl.Location = new System.Drawing.Point(0, 0);
            // 
            // superParametricKoeficientsControl1
            // 
            this.superParametricKoeficientsControl.Location =
                new System.Drawing.Point(0, centerKoeficientsControl.Height + LayoutProperties.TextTopSpace);
            this.Width = Math.Max(centerKoeficientsControl.Width, superParametricKoeficientsControl.Width);
            this.Height = superParametricKoeficientsControl.Location.Y + superParametricKoeficientsControl.Height;
        }


        private void InitializeComponent()
        {
            this.centerKoeficientsControl = new Geometry.GGraphic.Forms.Detail.Controls.CenterKoeficientsControl(Dimension.THREE);
            this.superParametricKoeficientsControl = new Geometry.GGraphic.Forms.Detail.Controls.IParametricKoeficientsControl();
            this.SuspendLayout();
            // 
            // centerKoeficientsControl
            // 
            this.centerKoeficientsControl.CausesValidation = false;
            this.centerKoeficientsControl.Location = new System.Drawing.Point(0, 0);
            this.centerKoeficientsControl.Name = "centerKoeficientsControl";
            this.centerKoeficientsControl.Size = new System.Drawing.Size(367, 30);
            this.centerKoeficientsControl.TabIndex = 1;
            // 
            // superParametricKoeficientsControl
            // 
            this.superParametricKoeficientsControl.BackColor = System.Drawing.Color.Aqua;
            this.superParametricKoeficientsControl.CausesValidation = false;
            this.superParametricKoeficientsControl.Location = new System.Drawing.Point(0, 30);
            this.superParametricKoeficientsControl.Name = "superParametricKoeficientsControl";
            this.superParametricKoeficientsControl.Size = new System.Drawing.Size(150, 150);
            this.superParametricKoeficientsControl.TabIndex = 0;
            // 
            // KoefsAndCenterControl
            // 
            this.Controls.Add(this.superParametricKoeficientsControl);
            this.Controls.Add(this.centerKoeficientsControl);
            this.Name = "KoefsAndCenterControl";
            this.Size = new System.Drawing.Size(365, 26);
            this.ResumeLayout(false);

        }


        public KoefsAndCenterPair ParseKoefsAndCenterPair() 
        {
            return new KoefsAndCenterPair(
                superParametricKoeficientsControl.ParseParametricEquation(),
                centerKoeficientsControl.ParseCenter());
        }
    }
}
