﻿using System;
using System.Drawing;
using System.Windows.Forms;
using Geometry.GGraphic.Forms.Detail.Layout; 

namespace Geometry.GGraphic.Forms.Detail.Controls
{
    public partial class NameAndColorControl : UserControl
    {
        public NameAndColorControl()
        {
            InitializeComponent();
            PerformCustomLayout();
        }



        public void SetColor(Color color) { panelColor.BackColor = color; }
        public void SetName(string name) { textBoxName.Text = name; }



        private void PerformCustomLayout() 
        {
            int labelDif = (buttonColor.Height - labelName.PreferredHeight) / 2;
            int textboxDif = (buttonColor.Height - textBoxName.Height) / 2;
            int panelDif = (buttonColor.Height - panelColor.Height) / 2;
            
            labelName.Location = new Point(0, labelDif);
            textBoxName.Location =
                new Point(labelName.Location.X + labelName.PreferredWidth + LayoutProperties.TextSideSpace - 2, 
                    textboxDif);

            labelColor.Location =
                new Point(textBoxName.Location.X + textBoxName.Width + LayoutProperties.TextSideSpace,
                    labelDif);
            panelColor.Location = 
                new Point(labelColor.Location.X + labelColor.PreferredWidth + LayoutProperties.TextSideSpace - 2,
                    panelDif);
            buttonColor.Location = 
                new Point(panelColor.Location.X + panelColor.Width + LayoutProperties.TextSideSpace, 0);

            this.Width = buttonColor.Location.X + buttonColor.Width;
            this.Height = buttonColor.Location.Y + buttonColor.Height;
        }

        private void buttonColor_Click(object sender, EventArgs e)
        {
            ColorDialog colorDialog = new ColorDialog();
            colorDialog.Color = panelColor.BackColor;
            // Keeps the user from selecting a custom color.
            colorDialog.AllowFullOpen = true;
            // Allows the user to get help. (The default is false.)
            if (colorDialog.ShowDialog() == DialogResult.OK)
            {
                panelColor.BackColor = colorDialog.Color;
            }
        }



        public Color GetColor() { return panelColor.BackColor; }
        public string GetName() { return textBoxName.Text; }

    }
}
