﻿using System;
using System.Collections.Generic;
using Geometry.GGraphic.Forms.Detail.Layout;
using System.Windows.Forms;
using System.Drawing;
using Geometry.GraphicObjects;
using Geometry.GGraphic.Controls.ElementaryControls;
using Geometry.GGraphic.Forms.Detail;
using Geometry.GGraphic.Controls.GroupBoxes;

namespace Geometry.GGraphic.Controls.TabPages
{
    public partial class EquationsTabPage : DynamicTabPage
    {
        protected IconLabel infoLabel1;
        protected IconLabel infoLabel2;
        protected IconLabel infoLabel3;
        protected EditButton edit1;
        protected EditButton edit2;
        protected EditButton edit3;
        protected DynamicGroupBox groupBoxCommon;
        protected DynamicGroupBox groupBoxCanonic;
        protected DynamicGroupBox groupBoxParametric;

        CommonEquationGR commomEquationControl;
        CanonicEquationGR canonicEquationControl;
        ParametricEquationsGR parametricEquationControl;

        CommonEquationGR commomEquationControlToolTip;
        CanonicEquationGR canonicEquationControlToolTip;
        ParametricEquationsGR parametricEquationControlToolTip;

        CustomToolTip _canonicalToolTip;
        CustomToolTip _parametricalToolTip;
        CustomToolTip _commonToolTip;


        protected Size _infoLabelSize = new Size(32, 32);

        protected Form1 _form;
        protected GraphicObjectDetail _graphicObjectDetail;


        public EquationsTabPage() { }

        /// <summary>
        /// Vsechny prvky jsou vytvoreny.
        /// Vsechny prvky jsou tam kde maji byt az na groupboxi a jejich rovnice.
        /// Potom se zavola AddEquations.
        /// - objekt musi mit alespon parametrickou rovnici, pridam groupBox do controls
        /// - pokud ma obecnou pridam obecnou, pridam groupBox do controls
        /// - pokud ma kanonickou prodam kanonickou, pridam groupBox do controls
        /// Pak pridam i toolTipy.
        /// Nakonec zavolat base.PerformLayout...
        /// </summary>
        public EquationsTabPage(Form1 form, GraphicObjectDetail detail, Size minimumSize)
            : base(minimumSize)
        {
            _form = form;
            _graphicObjectDetail = detail;
            InitializeComponents();
            this.Text = "Rovnice";
        }



        private void InitializeComponents()
        {
            SuspendLayout();
            this.commomEquationControl = new CommonEquationGR();
            this.canonicEquationControl = new CanonicEquationGR();
            this.parametricEquationControl = new ParametricEquationsGR();

            this.commomEquationControlToolTip = new CommonEquationGR();
            this.canonicEquationControlToolTip = new CanonicEquationGR();
            this.parametricEquationControlToolTip = new ParametricEquationsGR();

            this.infoLabel1 = new IconLabel();
            this.infoLabel2 = new IconLabel();
            this.infoLabel3 = new IconLabel();
            this.edit1 = new EditButton();
            this.edit2 = new EditButton();
            this.edit3 = new EditButton();

            this.groupBoxCommon = new DynamicGroupBox(base._minimumSize);
            this.groupBoxCanonic = new DynamicGroupBox(base._minimumSize);
            this.groupBoxParametric = new DynamicGroupBox(base._minimumSize);
            // 
            // groupBoxCommon
            // 
            this.groupBoxCommon.Location = new System.Drawing.Point(6, 6);
            this.groupBoxCommon.Name = "groupBoxCommon";
            this.groupBoxCommon.Size = new System.Drawing.Size(242, 60);
            this.groupBoxCommon.TabIndex = 56;
            this.groupBoxCommon.TabStop = false;
            this.groupBoxCommon.Text = "Rovnice ve standardní bázi:";
            // 
            // edit1
            // 
            this.edit1.Location = new System.Drawing.Point(161, 19);
            this.edit1.Name = "edit1";
            this.edit1.Size = new System.Drawing.Size(75, 23);
            this.edit1.TabIndex = 3;
            this.edit1.Text = "Editovat";
            this.edit1.UseVisualStyleBackColor = true;
            // 
            // infoLabel1
            // 
            this.infoLabel1.AutoSize = true;
            this.infoLabel1.Location = new System.Drawing.Point(120, 24);
            this.infoLabel1.Name = "infoLabel1";
            this.infoLabel1.Size = new System.Drawing.Size(35, 13);
            this.infoLabel1.TabIndex = 2;
            this.infoLabel1.Text = "label6";
            // 
            // groupBoxCanonic
            // 
            this.groupBoxCanonic.Location = new System.Drawing.Point(6, 72);
            this.groupBoxCanonic.Name = "groupBoxCanonic";
            this.groupBoxCanonic.Size = new System.Drawing.Size(242, 62);
            this.groupBoxCanonic.TabIndex = 55;
            this.groupBoxCanonic.TabStop = false;
            this.groupBoxCanonic.Text = "Kanonický tvar v polární bázi:";
            // 
            // infoLabel2
            // 
            this.infoLabel2.AutoSize = true;
            this.infoLabel2.Location = new System.Drawing.Point(120, 24);
            this.infoLabel2.Name = "infoLabel2";
            this.infoLabel2.Size = new System.Drawing.Size(35, 13);
            this.infoLabel2.TabIndex = 32;
            this.infoLabel2.Text = "label5";
            // 
            // edit2
            // 
            this.edit2.Location = new System.Drawing.Point(161, 19);
            this.edit2.Name = "edit2";
            this.edit2.Size = new System.Drawing.Size(75, 23);
            this.edit2.TabIndex = 31;
            this.edit2.Text = "Editovat";
            this.edit2.UseVisualStyleBackColor = true;
            // 
            // groupBoxParametric
            // 
            this.groupBoxParametric.Location = new System.Drawing.Point(6, 140);
            this.groupBoxParametric.Name = "groupBoxParametric";
            this.groupBoxParametric.Size = new System.Drawing.Size(242, 53);
            this.groupBoxParametric.TabIndex = 32;
            this.groupBoxParametric.TabStop = false;
            this.groupBoxParametric.Text = "Parametrické rovnice v  polární bázi:";
            // 
            // infoLabel3
            // 
            this.infoLabel3.Location = new System.Drawing.Point(0, 0);
            this.infoLabel3.Name = "infoLabel3";
            this.infoLabel3.Size = new System.Drawing.Size(100, 23);
            this.infoLabel3.TabIndex = 0;
            // 
            // edit3
            // 
            this.edit3.Location = new System.Drawing.Point(161, 19);
            this.edit3.Name = "edit3";
            this.edit3.Size = new System.Drawing.Size(75, 23);
            this.edit3.TabIndex = 32;
            this.edit3.Text = "Editovat";
            this.edit3.UseVisualStyleBackColor = true;


            edit1.Click += OnEditCommonEquationClick;
            edit2.Click += OnEditCanonicEquationClick;
            edit3.Click += OnEditParametricEquationClick;
            _commonToolTip = new CustomToolTip();
            _canonicalToolTip = new CustomToolTip();
            _parametricalToolTip = new CustomToolTip();

            infoLabel1.Text = "";
            infoLabel1.AutoSize = false;
            infoLabel1.Width = _infoLabelSize.Width;
            infoLabel1.Height = _infoLabelSize.Height;
            infoLabel1.Image = SystemIcons.Information.ToBitmap();
            infoLabel1.MouseEnter += new EventHandler(infoLabel1_MouseEnter);
            infoLabel1.MouseLeave += new EventHandler(infoLabel1_MouseLeave);

            infoLabel2.Text = "";
            infoLabel2.AutoSize = false;
            infoLabel2.Width = _infoLabelSize.Width;
            infoLabel2.Height = _infoLabelSize.Height;
            infoLabel2.Image = SystemIcons.Information.ToBitmap();
            infoLabel2.MouseEnter += new EventHandler(infoLabel2_MouseEnter);
            infoLabel2.MouseLeave += new EventHandler(infoLabel2_MouseLeave);

            infoLabel3.Text = "";
            infoLabel3.AutoSize = false;
            infoLabel3.Width = _infoLabelSize.Width;
            infoLabel3.Height = _infoLabelSize.Height;
            infoLabel3.Image = SystemIcons.Information.ToBitmap();
            infoLabel3.MouseEnter += new EventHandler(infoLabel3_MouseEnter);
            infoLabel3.MouseLeave += new EventHandler(infoLabel3_MouseLeave);

            edit1.DynamicWidth = edit1.Width; edit1.DynamicHeight = edit1.Height;
            edit2.DynamicWidth = edit2.Width; edit2.DynamicHeight = edit2.Height;
            edit3.DynamicWidth = edit3.Width; edit3.DynamicHeight = edit3.Height;
            infoLabel1.DynamicWidth = infoLabel1.Width; infoLabel1.DynamicHeight = infoLabel1.Height;
            infoLabel2.DynamicWidth = infoLabel2.Width; infoLabel2.DynamicHeight = infoLabel2.Height;
            infoLabel3.DynamicWidth = infoLabel3.Width; infoLabel3.DynamicHeight = infoLabel3.Height;


            groupBoxCommon.SetContents(new List<Control>() { commomEquationControl, infoLabel1, edit1 }, GroupBoxLayoutStyle.Equations);
            groupBoxCommon.Tag = false;

            groupBoxCanonic.SetContents(new List<Control>() { canonicEquationControl, infoLabel2, edit2 }, GroupBoxLayoutStyle.Equations);
            groupBoxCanonic.Tag = false;

            groupBoxParametric.SetContents(new List<Control>() { parametricEquationControl, infoLabel3, edit3 }, GroupBoxLayoutStyle.Equations);
            groupBoxParametric.Tag = false;

            ResumeLayout(false);
        }
        private void AddControls(GraphicObject graphicObject)
        {
            // pokud má objekt nejakou rovnici, jejiž groupBox není přidán, 
            // pak smažu všechny a znova přidám (kvůli pořadi). (stejne se bude pridavat.)
            // (předpoklám málo takových situací) v inicializaci, jinak zřídka
            // nebo pokud je pridan nejaky, ktery tam nema byt
            if (graphicObject is WithCommonEquationObject && !((bool)groupBoxCommon.Tag) ||
                graphicObject is WithCanonicEquationObject && !((bool)groupBoxCanonic.Tag) ||
                graphicObject is WithParametricEquationObject && !((bool)groupBoxParametric.Tag) ||
                (!(graphicObject is WithCommonEquationObject) && ((bool)groupBoxCommon.Tag)) ||
                (!(graphicObject is WithCanonicEquationObject) && ((bool)groupBoxCanonic.Tag)))
            {
                this.Controls.Clear();

                if (graphicObject is WithCommonEquationObject)
                {
                    this.Controls.Add(groupBoxCommon);
                    groupBoxCommon.Tag = true;
                }
                else
                    groupBoxCommon.Tag = false;

                if (graphicObject is WithCanonicEquationObject)
                {
                    this.Controls.Add(groupBoxCanonic);
                    groupBoxCanonic.Tag = true;
                }
                else
                    groupBoxCanonic.Tag = false;

                if (graphicObject is WithParametricEquationObject)
                {
                    this.Controls.Add(groupBoxParametric);
                    groupBoxParametric.Tag = true;
                }
                else
                    groupBoxParametric.Tag = false;
            }
        }
        public override void DisableButtons()
        {
            if (edit1 != null)
                edit1.Enabled = false;
            if (edit2 != null)
                edit2.Enabled = false;
            if (edit3 != null)
                edit3.Enabled = false;
        }
        public override void EnableButtons()
        {
            if (edit1 != null)
                edit1.Enabled = true;
            if (edit2 != null)
                edit2.Enabled = true;
            if (edit3 != null)
                edit3.Enabled = true;
        }
        public override void GenerateContents(GraphicObject graphicObject)
        {
            SuspendLayout();
            AddControls(graphicObject);
            if (graphicObject is WithCommonEquationObject)
            {
                CommonEquationChanged((WithCommonEquationObject)graphicObject);
            }
            if (graphicObject is WithCanonicEquationObject)
            {
                CanonicEquationChanged((WithCanonicEquationObject)graphicObject);
            }
            if (graphicObject is WithParametricEquationObject)
                ParametricEquationChanged((WithParametricEquationObject)graphicObject);
            base.SetDynamicFakeBounds();
            ResumeLayout(false);
        }



        private void CommonEquationChanged(WithCommonEquationObject graphicObject)
        {
            commomEquationControl.SetContents(
                graphicObject,
                graphicObject.GetCommonEquationFormatString().GetSubstitutedFormatString());

            commomEquationControlToolTip.SetContents(
                graphicObject,
                graphicObject.GetCommonEquationFormatString().GetGeneralFormatString());

            _commonToolTip.SetContents(commomEquationControlToolTip);
        }
        private void CanonicEquationChanged(WithCanonicEquationObject graphicObject)
        {
            canonicEquationControl.SetContents(
                graphicObject,
                graphicObject.GetCanonicEquationFormatString().GetSubstitutedFormatString());

            canonicEquationControlToolTip.SetContents(
                graphicObject,
                graphicObject.GetCanonicEquationFormatString().GetGeneralFormatString());

            _canonicalToolTip.SetContents(canonicEquationControlToolTip);
        }
        private void ParametricEquationChanged(WithParametricEquationObject graphicObject)
        {
            parametricEquationControl.SetContents(
                graphicObject,
                graphicObject.GetParametricEquationsFormatString().GetXSubstitutedFormatString(),
                graphicObject.GetParametricEquationsFormatString().GetYSubstitutedFormatString(),
                graphicObject.GetParametricEquationsFormatString().GetZSubstitutedFormatString());

            parametricEquationControlToolTip.SetContents(
                graphicObject,
                graphicObject.GetParametricEquationsFormatString().GetXGeneralFormatString(),
                graphicObject.GetParametricEquationsFormatString().GetYGeneralFormatString(),
                graphicObject.GetParametricEquationsFormatString().GetZGeneralFormatString());

            _parametricalToolTip.SetContents(parametricEquationControlToolTip);
        }



        private void infoLabel1_MouseEnter(object sender, EventArgs e)
        {
            int height = (SystemInformation.Border3DSize.Height +
                SystemInformation.BorderSize.Height +
                SystemInformation.FrameBorderSize.Height +
                SystemInformation.CaptionHeight);
            _commonToolTip.Show("s", this, infoLabel1.Location.X,
                groupBoxCommon.Location.Y + infoLabel1.Location.Y + 32 + 6);
        }
        private void infoLabel2_MouseEnter(object sender, EventArgs e)
        {
            int height = (SystemInformation.Border3DSize.Height +
                SystemInformation.BorderSize.Height +
                SystemInformation.FrameBorderSize.Height +
                SystemInformation.CaptionHeight);
            _canonicalToolTip.Show("s", this, infoLabel2.Location.X,
                groupBoxCanonic.Location.Y + infoLabel2.Location.Y + 32 + 6);
        }
        private void infoLabel3_MouseEnter(object sender, EventArgs e)
        {
            int height = (SystemInformation.Border3DSize.Height +
                SystemInformation.BorderSize.Height +
                SystemInformation.FrameBorderSize.Height +
                SystemInformation.CaptionHeight);
            _parametricalToolTip.Show("s", this, infoLabel3.Location.X,
                groupBoxParametric.Location.Y + infoLabel3.Location.Y + 32 + 6);
        }

        private void infoLabel1_MouseLeave(object sender, EventArgs e)
        {
            _commonToolTip.Hide(this);
        }
        private void infoLabel2_MouseLeave(object sender, EventArgs e)
        {
            _canonicalToolTip.Hide(this);
        }
        private void infoLabel3_MouseLeave(object sender, EventArgs e)
        {
            _parametricalToolTip.Hide(this);
        }



        protected virtual void OnEditCommonEquationClick(object sender, EventArgs e)
        {
            _form.GetManipulation().ChangeCommonEquationInvoked(
                (WithCommonEquationObject)_graphicObjectDetail.GetGraphicObject());
        }
        protected virtual void OnEditCanonicEquationClick(object sender, EventArgs e)
        {
            _form.GetManipulation().ChangeCanonicEquationInvoked(
                (WithCanonicEquationObject)_graphicObjectDetail.GetGraphicObject());
        }
        protected virtual void OnEditParametricEquationClick(object sender, EventArgs e)
        {
            _form.GetManipulation().ChangeParametricEquationInvoked(
                (WithParametricEquationObject)_graphicObjectDetail.GetGraphicObject());
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
        }
    }
}
