﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using Geometry.GGraphic.Forms.Detail.Layout;
using Geometry.GraphicObjects;
using Geometry.GraphicObjects.Planar;
using Geometry.GraphicObjects.Quadrics;
using Geometry.GraphicObjects.ConicSections;
using Geometry.GGraphic.Forms.Detail;

namespace Geometry.GGraphic.Controls.TabPages
{
    public partial class HelpTabPage : ConstantTabPage
    {
        protected SuperHelpControl _helpControl;

        public HelpTabPage()
        {
            this.Text = "Nápověda";
        }

        public override void GenerateContents(GraphicObject graphicObject)
        {
            this.Controls.Clear();
            if (graphicObject is Quadric)
            {
                _helpControl = new QuadricHelpControl();
                this.Controls.Add(_helpControl);
            }
            if (graphicObject is ConicSection)
            {
                _helpControl = new ConicHelpControl();
                this.Controls.Add(_helpControl);
            }
            if (graphicObject is Plan)
            {
                _helpControl = new PlanHelpControl();
                this.Controls.Add(_helpControl);
            }
            if (graphicObject is Line)
            {
                _helpControl = new LineHelpControl();
                this.Controls.Add(_helpControl);
            }
            PerformCustomLayout();
        }

        public override void DisableButtons()
        {
            return;
        }
        public override void EnableButtons()
        {
            return;
        }


        public void PerformCustomLayout()
        {
            SuspendLayout();
            int width = 0;
            int height = LayoutProperties.TabPageTopSpace;

            _helpControl.Location = new
                System.Drawing.Point(LayoutProperties.TabPageSideSpace, height); // Set groupBox Location
            width += _helpControl.Width;
            height += _helpControl.Height;

            _width = width + LayoutProperties.TabPageSideSpace * 3;
            _height = height + LayoutProperties.TabPageTopSpace;
            ResumeLayout();
        }

    }
}
