﻿using System;
using Geometry.GGraphic.Forms.Detail.FormatString;
using System.Drawing;
using Geometry.GraphicObjects;
using Geometry.GGraphic.Forms.Detail.Controls;
using Geometry.GraphicObjects.Equations;
using Geometry.GraphicObjects.ConicSections;
using Geometry.GraphicObjects.Quadrics;
using Geometry.GraphicObjects.Planar;
using Geometry.BaseClasses;
using GMath;
using Geometry.GGraphic.Forms.Detail;

namespace Geometry.GGraphic.Controls.TabPages
{
    public partial class PlanEquationsTabPage : EquationsTabPage
    {
        public PlanEquationsTabPage(Form1 form, GraphicObjectDetail detail, Size minimumSize)
            : base(form, detail, minimumSize)
        {
            this.Text = "Rovina";
        }
        private Plan GetThePlan(GraphicObject graphicObject)
        {
            if (graphicObject is ConicSection)
                return ((ConicSection)graphicObject).GetConicPlan();
            if (graphicObject is Line)
                return ((Line)graphicObject).GetLinePlan();
            throw new Exception("Snazim se vytvorit detail rovnice objektu, ktery rovnici nema nebo se na nej zapomnelo.");
        }
        /// <summary>
        /// Graficky objekt je kuželosečka nebo přímka. 
        /// </summary>
        public override void GenerateContents(GraphicObject graphicObject)
        {
            Plan plan = GetThePlan(graphicObject);
            base.GenerateContents(plan);
        }



        protected override void OnEditCommonEquationClick(object sender, EventArgs e)
        {
            _form.GetManipulation().EditObjectsPlanCommonlyInvoked(
                (WithParametricEquationObject)_graphicObjectDetail.GetGraphicObject());
        }

        protected override void OnEditParametricEquationClick(object sender, EventArgs e)
        {
            _form.GetManipulation().EditObjectsPlanParametricalyInvoked(
                (WithParametricEquationObject)_graphicObjectDetail.GetGraphicObject());
        }
    }
}
