﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using Geometry.GraphicObjects;
using Geometry.GraphicObjects.Intersections;
using Geometry.GGraphic.Forms.Detail.Layout;
 
using Geometry.GGraphic.Controls.ElementaryControls;
using Geometry.GGraphic.Forms.Detail;
using Geometry.GGraphic.Controls.GroupBoxes;

namespace Geometry.GGraphic.Controls.TabPages
{
    public partial class PointsTabPage : ConstantTabPage
    {
        protected System.Windows.Forms.Label infoLabel1;
        protected System.Windows.Forms.Label infoLabel2;
        protected System.Windows.Forms.Label infoLabel3;
        protected System.Windows.Forms.Label infoLabel4;
        protected System.Windows.Forms.Button edit1;
        protected System.Windows.Forms.Button edit2;
        protected System.Windows.Forms.Button edit3;
        protected System.Windows.Forms.Button edit4;

        List<ConstantGroupBox> groupBoxes;

        protected ConstantGroupBox groupBoxPoint1;
        protected ConstantGroupBox groupBoxPoint2;
        protected ConstantGroupBox groupBoxPoint3;
        protected ConstantGroupBox groupBoxPoint4;

        List<CenterGR> pointEquationConrols;

        CenterGR pointEquationControl1;
        CenterGR pointEquationControl2;
        CenterGR pointEquationControl3;
        CenterGR pointEquationControl4;

        ParametricEquationsGR pointEquationControlToolTip;

        CustomToolTip pointToolTip;


        protected Size _infoLabelSize = new Size(32, 32);

        protected Form1 _form;
        protected GraphicObjectDetail _graphicObjectDetail;


        public PointsTabPage() { }

        /// <summary>
        /// Vsechny prvky jsou vytvoreny.
        /// Vsechny prvky jsou tam kde maji byt az na groupboxi a jejich rovnice.
        /// Potom se zavola AddEquations.
        /// - objekt musi mit alespon parametrickou rovnici, pridam groupBox do controls
        /// - pokud ma obecnou pridam obecnou, pridam groupBox do controls
        /// - pokud ma kanonickou prodam kanonickou, pridam groupBox do controls
        /// Pak pridam i toolTipy.
        /// Nakonec zavolat base.PerformLayout...
        /// </summary>
        public PointsTabPage(Form1 form, GraphicObjectDetail detail, Size minimumSize)
            : base(minimumSize)
        {
            _form = form;
            _graphicObjectDetail = detail;
            InitializeComponents();
            this.Text = "Rovnice";
        }



        private void InitializeComponents()
        {
            SuspendLayout();
            this.pointEquationControl1 = new CenterGR();
            this.pointEquationControl2 = new CenterGR();
            this.pointEquationControl3 = new CenterGR();
            this.pointEquationControl4 = new CenterGR();

            this.pointEquationControlToolTip = new ParametricEquationsGR();

            this.infoLabel1 = new System.Windows.Forms.Label();
            this.infoLabel2 = new System.Windows.Forms.Label();
            this.infoLabel3 = new System.Windows.Forms.Label();
            this.infoLabel4 = new System.Windows.Forms.Label();
            this.edit1 = new System.Windows.Forms.Button();
            this.edit2 = new System.Windows.Forms.Button();
            this.edit3 = new System.Windows.Forms.Button();
            this.edit4 = new System.Windows.Forms.Button();

            this.groupBoxPoint1 = new ConstantGroupBox(base._minimumSize);
            this.groupBoxPoint2 = new ConstantGroupBox(base._minimumSize);
            this.groupBoxPoint3 = new ConstantGroupBox(base._minimumSize);
            this.groupBoxPoint4 = new ConstantGroupBox(base._minimumSize);
            // 
            // groupBoxPoint1
            // 
            this.groupBoxPoint1.Location = new System.Drawing.Point(6, 6);
            this.groupBoxPoint1.Name = "groupBoxPoint1";
            this.groupBoxPoint1.Size = new System.Drawing.Size(242, 60);
            this.groupBoxPoint1.TabIndex = 56;
            this.groupBoxPoint1.TabStop = false;
            this.groupBoxPoint1.Text = "Souřadnice prvního bodu:";
            // 
            // edit1
            // 
            this.edit1.Location = new System.Drawing.Point(161, 19);
            this.edit1.Name = "edit1";
            this.edit1.Size = new System.Drawing.Size(75, 23);
            this.edit1.TabIndex = 3;
            this.edit1.Text = "Editovat";
            this.edit1.UseVisualStyleBackColor = true;
            // 
            // infoLabel1
            // 
            this.infoLabel1.AutoSize = true;
            this.infoLabel1.Location = new System.Drawing.Point(120, 24);
            this.infoLabel1.Name = "infoLabel1";
            this.infoLabel1.Size = new System.Drawing.Size(35, 13);
            this.infoLabel1.TabIndex = 2;
            this.infoLabel1.Text = "label6";
            // 
            // groupBoxPoint2
            // 
            this.groupBoxPoint2.Location = new System.Drawing.Point(6, 72);
            this.groupBoxPoint2.Name = "groupBoxPoint2";
            this.groupBoxPoint2.Size = new System.Drawing.Size(242, 62);
            this.groupBoxPoint2.TabIndex = 55;
            this.groupBoxPoint2.TabStop = false;
            this.groupBoxPoint2.Text = "Souřadnice druhého bodu:";
            // 
            // infoLabel2
            // 
            this.infoLabel2.AutoSize = true;
            this.infoLabel2.Location = new System.Drawing.Point(120, 24);
            this.infoLabel2.Name = "infoLabel2";
            this.infoLabel2.Size = new System.Drawing.Size(35, 13);
            this.infoLabel2.TabIndex = 32;
            this.infoLabel2.Text = "label5";
            // 
            // edit2
            // 
            this.edit2.Location = new System.Drawing.Point(161, 19);
            this.edit2.Name = "edit2";
            this.edit2.Size = new System.Drawing.Size(75, 23);
            this.edit2.TabIndex = 31;
            this.edit2.Text = "Editovat";
            this.edit2.UseVisualStyleBackColor = true;
            // 
            // groupBoxPoint3
            // 
            this.groupBoxPoint3.Location = new System.Drawing.Point(6, 140);
            this.groupBoxPoint3.Name = "groupBoxPoint3";
            this.groupBoxPoint3.Size = new System.Drawing.Size(242, 53);
            this.groupBoxPoint3.TabIndex = 32;
            this.groupBoxPoint3.TabStop = false;
            this.groupBoxPoint3.Text = "Souřadnice třetího bodu:";
            // 
            // infoLabel3
            // 
            this.infoLabel3.Location = new System.Drawing.Point(0, 0);
            this.infoLabel3.Name = "infoLabel3";
            this.infoLabel3.Size = new System.Drawing.Size(100, 23);
            this.infoLabel3.TabIndex = 0;
            // 
            // edit3
            // 
            this.edit3.Location = new System.Drawing.Point(161, 19);
            this.edit3.Name = "edit3";
            this.edit3.Size = new System.Drawing.Size(75, 23);
            this.edit3.TabIndex = 32;
            this.edit3.Text = "Editovat";
            this.edit3.UseVisualStyleBackColor = true;
            // 
            // groupBoxPoint4
            // 
            this.groupBoxPoint4.Location = new System.Drawing.Point(6, 170);
            this.groupBoxPoint4.Name = "groupBoxPoint4";
            this.groupBoxPoint4.Size = new System.Drawing.Size(242, 53);
            this.groupBoxPoint4.TabIndex = 32;
            this.groupBoxPoint4.TabStop = false;
            this.groupBoxPoint4.Text = "Souřadnice čtvrtého bodu:";
            // 
            // infoLabel4
            // 
            this.infoLabel4.Location = new System.Drawing.Point(0, 0);
            this.infoLabel4.Name = "infoLabel4";
            this.infoLabel4.Size = new System.Drawing.Size(100, 23);
            this.infoLabel4.TabIndex = 0;
            // 
            // edit4
            // 
            this.edit4.Location = new System.Drawing.Point(161, 19);
            this.edit4.Name = "edit4";
            this.edit4.Size = new System.Drawing.Size(75, 23);
            this.edit4.TabIndex = 32;
            this.edit4.Text = "Editovat";
            this.edit4.UseVisualStyleBackColor = true;


            pointToolTip = new CustomToolTip();

            infoLabel1.Text = "";
            infoLabel1.AutoSize = false;
            infoLabel1.Width = _infoLabelSize.Width;
            infoLabel1.Height = _infoLabelSize.Height;
            infoLabel1.Image = SystemIcons.Information.ToBitmap();
            infoLabel1.MouseEnter += new EventHandler(infoLabel1_MouseEnter);
            infoLabel1.MouseLeave += new EventHandler(infoLabel1_MouseLeave);

            infoLabel2.Text = "";
            infoLabel2.AutoSize = false;
            infoLabel2.Width = _infoLabelSize.Width;
            infoLabel2.Height = _infoLabelSize.Height;
            infoLabel2.Image = SystemIcons.Information.ToBitmap();
            infoLabel2.MouseEnter += new EventHandler(infoLabel2_MouseEnter);
            infoLabel2.MouseLeave += new EventHandler(infoLabel2_MouseLeave);

            infoLabel3.Text = "";
            infoLabel3.AutoSize = false;
            infoLabel3.Width = _infoLabelSize.Width;
            infoLabel3.Height = _infoLabelSize.Height;
            infoLabel3.Image = SystemIcons.Information.ToBitmap();
            infoLabel3.MouseEnter += new EventHandler(infoLabel3_MouseEnter);
            infoLabel3.MouseLeave += new EventHandler(infoLabel3_MouseLeave);

            infoLabel4.Text = "";
            infoLabel4.AutoSize = false;
            infoLabel4.Width = _infoLabelSize.Width;
            infoLabel4.Height = _infoLabelSize.Height;
            infoLabel4.Image = SystemIcons.Information.ToBitmap();
            infoLabel4.MouseEnter += new EventHandler(infoLabel4_MouseEnter);
            infoLabel4.MouseLeave += new EventHandler(infoLabel4_MouseLeave);


            groupBoxPoint1.SetContents(new List<Control>() { pointEquationControl1, infoLabel1, edit1 }, GroupBoxLayoutStyle.Equations);
            groupBoxPoint1.Tag = false;

            groupBoxPoint2.SetContents(new List<Control>() { pointEquationControl2, infoLabel2, edit2 }, GroupBoxLayoutStyle.Equations);
            groupBoxPoint2.Tag = false;

            groupBoxPoint3.SetContents(new List<Control>() { pointEquationControl3, infoLabel3, edit3 }, GroupBoxLayoutStyle.Equations);
            groupBoxPoint3.Tag = false;

            groupBoxPoint4.SetContents(new List<Control>() { pointEquationControl4, infoLabel4, edit4 }, GroupBoxLayoutStyle.Equations);
            groupBoxPoint4.Tag = false;

            groupBoxes = new List<ConstantGroupBox>() { groupBoxPoint1, groupBoxPoint2, groupBoxPoint3, groupBoxPoint4 };
            pointEquationConrols = new List<CenterGR>() { pointEquationControl1, pointEquationControl2, pointEquationControl3, pointEquationControl4 };

            GraphicObjects.Planar.GPoint p = new Geometry.GraphicObjects.Planar.GPoint(new GMath.Vector(), new GColor(1, 1, 1), "", -1);
            pointEquationControlToolTip.SetContents(p,
                p.GetParametricEquationsFormatString().GetXGeneralFormatString(),
                p.GetParametricEquationsFormatString().GetYGeneralFormatString(),
                p.GetParametricEquationsFormatString().GetZGeneralFormatString());
            pointToolTip.SetContents(pointEquationControlToolTip);

            this.Controls.Add(groupBoxPoint1); // vložím všechny groupBoxi
            this.Controls.Add(groupBoxPoint2);
            this.Controls.Add(groupBoxPoint3);
            this.Controls.Add(groupBoxPoint4);
            base.SetConstantSize(); // a nastavím jim jejich konstantní pozice a lokace.
            this.Controls.Clear(); // všechny groupBoxi odstraním a při generaceContents se přidají ty správné.
            // podle toho který je nejníž se nastaví výška stránky.
            ResumeLayout(false);
        }
        private void AddControls(int countOfPoints)
        {
            int countOfGroupBoxesBefore = 0;
            if ((bool)groupBoxPoint1.Tag) countOfGroupBoxesBefore++;
            if ((bool)groupBoxPoint2.Tag) countOfGroupBoxesBefore++;
            if ((bool)groupBoxPoint3.Tag) countOfGroupBoxesBefore++;
            if ((bool)groupBoxPoint4.Tag) countOfGroupBoxesBefore++;

            if (countOfGroupBoxesBefore >= countOfPoints)
            {
                for (int i = countOfPoints; i < countOfGroupBoxesBefore; i++)
                {
                    ConstantGroupBox groupBox = this.groupBoxes[i];
                    groupBox.Tag = false;
                    this.Controls.Remove(groupBox);
                }
            }
            else
            {
                for (int i = countOfGroupBoxesBefore; i < countOfPoints; i++)
                {
                    ConstantGroupBox groupBox = this.groupBoxes[i];
                    groupBox.Tag = true;
                    this.Controls.Add(groupBox);
                }
            }
        }
        public override void DisableButtons()
        {
            if (edit1 != null)
                edit1.Enabled = false;
            if (edit2 != null)
                edit2.Enabled = false;
            if (edit3 != null)
                edit3.Enabled = false;
            if (edit4 != null)
                edit4.Enabled = false;
        }
        public override void EnableButtons()
        {
            if (edit1 != null)
                edit1.Enabled = true;
            if (edit2 != null)
                edit2.Enabled = true;
            if (edit3 != null)
                edit3.Enabled = true;
            if (edit4 != null)
                edit4.Enabled = true;
        }
        public override void GenerateContents(GraphicObject graphicObject)
        {
            IIntersection section = (IIntersection)graphicObject;

            List<GraphicObject> points = new List<GraphicObject>();
            foreach (GraphicObject g in section.GetIntersections())
                if (g is Geometry.GraphicObjects.Planar.GPoint)
                {
                    points.Add(g);
                }
            int countOfPoints = Math.Min(points.Count, 4);
            SuspendLayout();

            AddControls(countOfPoints);
            int height = 0;
            for (int i = 0; i < countOfPoints; i++)
            {
                GraphicObjects.Planar.GPoint p = (GraphicObjects.Planar.GPoint)points[i];
                pointEquationConrols[i].SetContents(points[i],
                    p.GetParametricEquationsFormatString().GetXSubstitutedFormatString(),
                    p.GetParametricEquationsFormatString().GetYSubstitutedFormatString(),
                    p.GetParametricEquationsFormatString().GetZSubstitutedFormatString());
                SetNeededHeight(groupBoxes[i]);
            }
            if (countOfPoints > 1)
                this.Text = "Body";
            else this.Text = "Bod";
            this.Height = height;
            ResumeLayout(false);
        }



        private void infoLabel1_MouseEnter(object sender, EventArgs e)
        {
            int height = (SystemInformation.Border3DSize.Height +
                SystemInformation.BorderSize.Height +
                SystemInformation.FrameBorderSize.Height +
                SystemInformation.CaptionHeight);
            pointToolTip.Show("s", this, infoLabel1.Location.X,
                groupBoxPoint1.Location.Y + infoLabel1.Location.Y + 32 + 6);
        }
        private void infoLabel2_MouseEnter(object sender, EventArgs e)
        {
            int height = (SystemInformation.Border3DSize.Height +
                SystemInformation.BorderSize.Height +
                SystemInformation.FrameBorderSize.Height +
                SystemInformation.CaptionHeight);
            pointToolTip.Show("s", this, infoLabel2.Location.X,
                groupBoxPoint2.Location.Y + infoLabel2.Location.Y + 32 + 6);
        }
        private void infoLabel3_MouseEnter(object sender, EventArgs e)
        {
            int height = (SystemInformation.Border3DSize.Height +
                SystemInformation.BorderSize.Height +
                SystemInformation.FrameBorderSize.Height +
                SystemInformation.CaptionHeight);
            pointToolTip.Show("s", this, infoLabel3.Location.X,
                groupBoxPoint3.Location.Y + infoLabel3.Location.Y + 32 + 6);
        }
        private void infoLabel4_MouseEnter(object sender, EventArgs e)
        {
            int height = (SystemInformation.Border3DSize.Height +
                SystemInformation.BorderSize.Height +
                SystemInformation.FrameBorderSize.Height +
                SystemInformation.CaptionHeight);
            pointToolTip.Show("s", this, infoLabel4.Location.X,
                groupBoxPoint4.Location.Y + infoLabel4.Location.Y + 32 + 6);
        }

        private void infoLabel1_MouseLeave(object sender, EventArgs e)
        {
            pointToolTip.Hide(this);
        }
        private void infoLabel2_MouseLeave(object sender, EventArgs e)
        {
            pointToolTip.Hide(this);
        }
        private void infoLabel3_MouseLeave(object sender, EventArgs e)
        {
            pointToolTip.Hide(this);
        }
        private void infoLabel4_MouseLeave(object sender, EventArgs e)
        {
            pointToolTip.Hide(this);
        }



        protected void OnEditCommonEquationClick(object sender, EventArgs e)
        {
            _form.GetManipulation().ChangeCommonEquationInvoked(
                (WithCommonEquationObject)_graphicObjectDetail.GetGraphicObject());
        }
        protected void OnEditCanonicEquationClick(object sender, EventArgs e)
        {
            _form.GetManipulation().ChangeCanonicEquationInvoked(
                (WithCanonicEquationObject)_graphicObjectDetail.GetGraphicObject());
        }
        protected void OnEditParametricEquationClick(object sender, EventArgs e)
        {
            _form.GetManipulation().ChangeParametricEquationInvoked(
                (WithParametricEquationObject)_graphicObjectDetail.GetGraphicObject());
        }
    }
}
