﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Tao.OpenGl;
using Geometry.GraphicObjects;
using GMath;
using Tao.Platform.Windows; 

namespace Geometry.GGraphic.Forms.AddForms
{
    public class AddIntersectionScene:Scene
    {

        public AddIntersectionScene() : base() { }

        public new void RenderScene()
        {
            Gl.glClear(Gl.GL_COLOR_BUFFER_BIT | Gl.GL_DEPTH_BUFFER_BIT);
            Gl.glMatrixMode(Gl.GL_MODELVIEW);
            Gl.glLoadIdentity();
            Vector center = _centerOfScene.GetCenterInStandardBasis().GetReprezentant();
            Gl.glTranslated(0, 0, -_zoom);

            Gl.glRotated(-_angles.GetXAngle(), 1, 0, 0);
            Gl.glRotated(-_angles.GetYAngle(), 0, 1, 0);

            Gl.glTranslated(-center.GetX(), -center.GetY(), -center.GetZ());

            CallClippingPlanes();

            foreach (GraphicObject graphicObject in list)
            {
                Gl.glPolygonMode(Gl.GL_FRONT_AND_BACK, Gl.GL_FILL);
                graphicObject.DrawIgnoreVisibilityAndAxes(this);
            }
            _centerOfScene.Draw(this);
            if (_doubleBuffered)
                Wgl.wglSwapBuffers(_hDC);
            else Gl.glFlush();
        }
    }
}
