﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Geometry.GGraphic.Forms.Detail;
using Geometry.GGraphic;
using Geometry.GraphicObjects;
using Geometry.GGraphic.Forms.Detail.FormatString;
using Geometry.GGraphic.Forms.Detail.Controls;
using Geometry.GraphicObjects.Equations;
using Geometry.GGraphic.Forms.Detail.Layout;
using Geometry.GGraphic.Controls;

namespace Geometry.GGraphic.Forms.AddForms
{
    public partial class AddGraphicObjectParametricalyDialog : IEditEquation
    {
        protected KoefsAndCenterPair _actualKoefsAndCenterPair;

        public AddGraphicObjectParametricalyDialog() 
        {
            InitializeComponent();
        }
 
        public AddGraphicObjectParametricalyDialog(ManipulationManager manipulationManager, GraphicObject graphicObject,
            ParametricEquationsGR canonicControl, KoefsAndCenterControl koefsAndCenterControl)
            : base(manipulationManager, graphicObject, canonicControl, koefsAndCenterControl)
        {
            InitializeComponent();
            this.Text = "Přidat " + graphicObject.GetWordDescriptionFourthCase().ToLower();
            this.Text = this.Text.Substring(0, this.Text.Length - graphicObject.GetName().Length);
            this.nameAndColorControl1.SetName(graphicObject.GetName());
            this.nameAndColorControl1.SetColor(Program.ColorToSystemColor(graphicObject.GetColor()));
            koefsAndCenterControl.TabIndex = 0;
            nameAndColorControl1.TabIndex = 1;


            canonicControl.SetRealDynamicSize();
            PerformCustomLayout(new List<Control>() { _groupBox, _koeficientsControl, this.nameAndColorControl1 });
        }

        public AddGraphicObjectParametricalyDialog(ManipulationManager manipulationManager, GraphicObject graphicObject,
            CanonicEquationGR canonicControl, KoefsAndCenterControl koefsAndCenterControl)
            : base(manipulationManager, graphicObject, canonicControl, koefsAndCenterControl)
        {
            InitializeComponent();
            _equationGRControl = canonicControl;
            _koeficientsControl = koefsAndCenterControl;
            this.Text = "Přidat " + graphicObject.GetWordDescriptionFourthCase().ToLower();
            this.Text = this.Text.Substring(0, this.Text.Length - graphicObject.GetName().Length);
            this.nameAndColorControl1.SetName(graphicObject.GetName());
            this.nameAndColorControl1.SetColor(Program.ColorToSystemColor(graphicObject.GetColor()));
            koefsAndCenterControl.TabIndex = 0;
            nameAndColorControl1.TabIndex = 1;

            canonicControl.SetRealDynamicSize();
            _groupBox.SetConstantMimimumSize();
            PerformCustomLayout(new List<Control>() { _groupBox, _koeficientsControl, this.nameAndColorControl1 });
        }


        public KoefsAndCenterPair GetKoefsAndCenterPair()
        {
            return _actualKoefsAndCenterPair;
        }
        public GColor GetColor()
        {
            return Program.SystemColorToColor(this.nameAndColorControl1.GetColor());
        }
        public string GetName()
        {
            return this.nameAndColorControl1.GetName();
        }

        protected override void OkButtonClick(object sender, EventArgs e)
        {
            KoefsAndCenterControl koefsAndCenterControl = (KoefsAndCenterControl)_koeficientsControl;
            _actualKoefsAndCenterPair = koefsAndCenterControl.ParseKoefsAndCenterPair();
            // null znamená chybu, informace o ní však již byla sdělena.
            if (_actualKoefsAndCenterPair.GetCenterParametrization() != null &&
                _actualKoefsAndCenterPair.GetParametricEquation() != null)
            {
                DialogResult = DialogResult.OK;
                Close();
            }
        }
    }
}
