﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Geometry.GGraphic.Forms.Detail;
using Geometry.GGraphic.Forms.Detail.FormatString;
using Geometry.GGraphic.Forms.Detail.Layout;
using Geometry.GGraphic.Forms.Detail.Controls;

using Geometry.GraphicObjects;
using Geometry.GraphicObjects.ConicSections;
using Geometry.GGraphic.Controls.TabPages;


namespace Geometry.GGraphic.Forms.Detail
{
    public partial class ConicDetail : GraphicObjectDetail
    {

        public ConicDetail(Form1 form, ConicSection conic): base(form, conic)
        {
            InitializeComponent();
            base.SetWindowProperties();
            this.Text = "Detail kuželosečky";
            _graphicObject = conic;

            SuspendLayout();
            EquationsTabPage equationsTabPage = new EquationsTabPage(_form, this, _minimumGroupBoxSize);
            PlanEquationsTabPage planEquationsTabPage = new PlanEquationsTabPage(_form, this, _minimumGroupBoxSize);            
            CenterTabPage centerTabPage = new CenterTabPage(_form, this, _minimumGroupBoxSize);
            RotationTabPage rotationTabPage = new RotationTabPage(_form, this, _minimumGroupBoxSize);
            DrawableTabPage drawableTabPage = new DrawableTabPage(_form, this, _minimumGroupBoxSize);
            base.AddToTabControl(equationsTabPage);
            base.AddToTabControl(planEquationsTabPage);
            base.AddToTabControl(centerTabPage);
            base.AddToTabControl(rotationTabPage);
            base.AddToTabControl(drawableTabPage);
            GenerateContents(_graphicObject);
            ResumeLayout();
            Rescale();
        }
    }
}