﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Geometry.GraphicObjects;
using Geometry.GraphicObjects.Planar;
using Geometry.GGraphic.Controls.TabPages;
 

namespace Geometry.GGraphic.Forms.Detail
{
    public partial class PlanDetail : GraphicObjectDetail
    {
        private EquationsTabPage equationsTabPage;
        private CenterTabPage centerTabPage;
        private RotationTabPage rotationTabPage;
        private DrawableTabPage drawableTabPage;

        public PlanDetail(Form1 form, Plan plan)
            : base(form, plan)
        {
            InitializeComponent();
            base.SetWindowProperties();
            this.Text = "Detail roviny";
            _graphicObject = plan;
            equationsTabPage = new EquationsTabPage(_form, this, _minimumGroupBoxSize);
            centerTabPage = new CenterTabPage(_form, this, _minimumGroupBoxSize);
            rotationTabPage = new RotationTabPage(_form, this, _minimumGroupBoxSize);
            drawableTabPage = new DrawableTabPage(_form, this, _minimumGroupBoxSize);
            SuspendLayout();

            base.AddToTabControl(equationsTabPage);
            base.AddToTabControl(centerTabPage);
            base.AddToTabControl(rotationTabPage);
            base.AddToTabControl(drawableTabPage);
            GenerateContents(plan);
            ResumeLayout();
            Rescale();
        }
    }
}
