﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace Geometry.GGraphic.Forms.Detail
{
    public class SuspendRedrawManager
    {
        private const int WM_SETREDRAW      = 0x000B;
        private const int WM_USER           = 0x400;
        private const int EM_GETEVENTMASK   = (WM_USER + 59);
        private const int EM_SETEVENTMASK   = (WM_USER + 69);

        private int _drawStopCount = 0;


        [DllImport("user32", CharSet = CharSet.Auto)]
        private extern static IntPtr SendMessage(IntPtr hWnd, int msg, int wParam, IntPtr lParam);

        IntPtr eventMask = IntPtr.Zero;

        private Form _form;

        public SuspendRedrawManager(Form form) 
        {
            _form = form;
        }

        public void StopDrawing()
        {
            if (_drawStopCount == 0)
            {
                // Stop redrawing:
                SendMessage(_form.Handle, WM_SETREDRAW, 0, IntPtr.Zero);
                // Stop sending of events:
                eventMask = SendMessage(_form.Handle, EM_GETEVENTMASK, 0, IntPtr.Zero);
            }
            _drawStopCount++;
        }

        public void StartDrawing()
        {
            _drawStopCount--;
            if (_drawStopCount == 0)
            {
                // turn on events
                SendMessage(_form.Handle, EM_SETEVENTMASK, 0, eventMask);

                // turn on redrawing
                SendMessage(_form.Handle, WM_SETREDRAW, 1, IntPtr.Zero);

                //_form.Invalidate();
                _form.Refresh();
            }
        }
    }
}
