﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Geometry.GraphicObjects;
using Geometry.GGraphic.Forms.Detail;
using Geometry.GGraphic;

namespace Geometry
{
    public partial class ChangeNameDialog : IDialog
    {
        private string _initialName;
        private string _actualName;

        public ChangeNameDialog(ManipulationManager manipulationManager, GraphicObject graphicObject)
            : base(manipulationManager, graphicObject)
        {
            InitializeComponent();
            GenerateContents(graphicObject);
        }

        public override void GenerateContents(GraphicObject graphicObject)
        {
            _graphicObject = graphicObject;
            _initialName = graphicObject.GetName();
            textBoxName.Text = graphicObject.GetName();
        }

        private string ParseName() 
        {
            return textBoxName.Text;
        }

        public string GetName() 
        {
            return _actualName;
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            _actualName = ParseName();
            if (_actualName != null) // null znamená chybu, informace o ní však již byla sdělena.
            {
                if (_initialName != _actualName)
                    DialogResult = DialogResult.OK;
                Close();
            }
        }

        private void stornoButton_Click(object sender, EventArgs e)
        {
            Close();
        }

        protected override void OnFormClosing(FormClosingEventArgs e)
        {
            _manipulationManager.ChangeNameClosed(this);
        }
    }
}
