﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Geometry.GGraphic.Forms.Detail;
using Geometry.GraphicObjects;

namespace Geometry.GGraphic.Forms.Detail.Dialogs
{
    public partial class EditCanonicCenterDialog : EditCenterDialog
    {
        public EditCanonicCenterDialog(ManipulationManager manipulationManager, WithCanonicEquationObject graphicObject)
            : base(manipulationManager, graphicObject)
        {
            _groupBox.Text = "Souřadnice vzhledem ke kanonické bázi:";
            GenerateContents(graphicObject);            
        }

        public override void GenerateContents(GraphicObject graphicObject) 
        {
            base.GenerateContents((WithCanonicEquationObject)graphicObject, 
                ((WithCanonicEquationObject)graphicObject).GetCenterInCanonicBasis());
        }

        protected override void OnFormClosing(FormClosingEventArgs e)
        {
            _manipulationManager.EditCanonicCenterClosed(this);
        }
    }
}
