﻿using System;
using System.Drawing;
using System.Windows.Forms;
using Geometry.GGraphic.Forms.Detail.Controls; 
using Geometry.GraphicObjects;

using Geometry.GGraphic.Forms.Detail.FormatString;
using Geometry.GGraphic.Forms.Detail.Layout;
using GMath;
using Geometry.GGraphic;
using System.Collections.Generic;
using Geometry.BaseClasses;
using Geometry.GGraphic.Controls;

namespace Geometry.GGraphic.Forms.Detail
{
    public partial class EditCenterDialog : IEditEquation
    {
        private CenterParametrization _initialCenter; // vstupní hodnoty
        private CenterParametrization _actualCenter; // aktuální hodnoty (v připadě potvrzení)

        public EditCenterDialog() { }

        public EditCenterDialog(ManipulationManager manipulationManager, GraphicObject graphicObject)
            : base(manipulationManager, graphicObject, new CenterGR(true), new CenterKoeficientsControl(Dimension.THREE))
        {
            this.Text = "Editace středu";
        }

        protected void GenerateContents(WithParametricEquationObject graphicObject, CenterParametrization center) 
        {
            _graphicObject = graphicObject;
            CenterFormatString centerFormatString = new CenterFormatString(center);            
            _equationGRControl.SetContents(
                graphicObject,
                centerFormatString.GetXGeneralFormatString(),
                centerFormatString.GetYGeneralFormatString(),
                centerFormatString.GetZGeneralFormatString());

            ((CenterKoeficientsControl)_koeficientsControl).SetContents(center);

            _initialCenter = ((CenterKoeficientsControl)_koeficientsControl).ParseCenter();
            PerformCustomLayout(new List<Control>() { _groupBox, _koeficientsControl });
        }

        public CenterParametrization GetCenter() 
        {
            return _actualCenter;
        }

        protected override void OkButtonClick(object sender, EventArgs e)
        {
            _actualCenter = ((CenterKoeficientsControl)_koeficientsControl).ParseCenter();
            if (_actualCenter != null) // null znamená chybu, informace o ní však již byla sdělena.
            {
                if (!CenterParametrization.AreEqualInTolerance(_initialCenter, _actualCenter))
                    DialogResult = DialogResult.OK;
                Close();
            }
        }
    }
}
