﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Geometry.GGraphic.Forms
{
    public partial class HelpForm : Form
    {
        private RichTextBox richtextbox = new RichTextBox();
        private Panel bottomPanel = new Panel();
        private Panel upPanel = new Panel();
        private ScrollBar scrollBar = new VScrollBar();
        private int distanceFromText = 30;
         

        public HelpForm()
        {
            InitializeComponent();
            this.ClientSize = new Size(600,500);
            //richtextbox.Cursor = Cursors.No;
            richtextbox.ReadOnly = true;
            richtextbox.BorderStyle = BorderStyle.None;
            richtextbox.BackColor = System.Drawing.Color.White; //this.BackColor;
            this.BackColor = System.Drawing.Color.White;
            richtextbox.Location = new Point(distanceFromText,0);
            richtextbox.Size = new Size(this.ClientSize.Width - distanceFromText, this.ClientSize.Height - 10);
            richtextbox.Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Bottom | AnchorStyles.Right;
            richtextbox.ScrollBars = RichTextBoxScrollBars.Vertical;


            string temp = System.Environment.NewLine + System.Environment.NewLine + System.Environment.NewLine + System.Environment.NewLine;
            richtextbox.AppendText(temp);  
            int richTextBoxLength = richtextbox.Text.Length;
            temp = "1.1 Manipulace se scénou" + System.Environment.NewLine;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;
            richtextbox.SelectionFont = new Font(richtextbox.Font, FontStyle.Bold);
            temp =
                "Scénu je možno tažením myší při stisknutém levém tlačítku myši posunovat horizontálně i vertikálně. Posunutou scénu lze vrátit do výchozí pozice klepnutím na položku menu  Úpravy/Vycentrovat scénu nebo stiskem kombinace kláves Ctrl+Space. Tažením myší při stisknutém pravém tlačítku myši dochází k rotaci scény okolo středu obrazovky. Tažením myší ve vertikálním směru při stisknutém středním tlačítku myši  dochází k přibližování a oddalování scény. Přiblížení či oddálení scény je možno realizovat i rotací kolečka myši nebo pomocí posuvníku, který se nachází na pravém okraji vykreslovací oblasti. " +
                System.Environment.NewLine +
                System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;

            temp = "1.2 Kontextové menu" + System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;
            richtextbox.SelectionFont = new Font(richtextbox.Font, FontStyle.Bold);
            temp = 
                "Prvek zobrazující seznam všech objektů nacházejících se ve scéně, umožňuje zobrazit kontextové menu s jehož pomocí lze rychle provádět vybrané operace nad objekty. Mezi tyto operace patří:"+
                System.Environment.NewLine + System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;
            temp =
                "1. Skrýt výběr - skryje všechny označené objekty" + System.Environment.NewLine +
                "2. Zobrazit výběr - zobrazí všechny označené objekty" + System.Environment.NewLine +
                "3. Smazat výber - smaže všechny označené objekty" + System.Environment.NewLine +
                "4. Přejmenovat výběr - zobrazí dialog editace jména, změnu aplikuje označenému objektu" + System.Environment.NewLine +
                "5. Přebarvit výběr - zobrazí dialog editace barvy, změnu aplikuje na všechny označené objekty" + System.Environment.NewLine +
                "6. Přidat průnik výběru - zobrazí dialog pro přidání průniku dvou označených objektů" + System.Environment.NewLine +
                "7. Skrýt osy výběru - skryje osy všech označených objektů" + System.Environment.NewLine +
                "8. Zobrazit osy výběru - zobrazí osy všech označených objektů" + System.Environment.NewLine +
                System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;

            temp =
                "Pro označení položky v seznamu objektů klepneme na položku. Pro označení další položky stiskneme Ctrl a klepneme na položku. Zobrazení kontextového menu provedeme klepnutím pravého tlačítka myši nad jednou z označených položek. Není-li daná akce kontextového menu aplikovatelná na počet nebo typ označených objektů, je tato akce nedostupná." +
                System.Environment.NewLine +
                System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;

            temp = "1.3 Přidání geometrického objektu" + System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;
            richtextbox.SelectionFont = new Font(richtextbox.Font, FontStyle.Bold);
            temp =
                "Přidání geometrického objektu do scény provedeme klepnutím na příslušnou"+
                " položku standardního menu. Možností pro přidání průniku dvou geometrických"+
                " objektů je i výše zmíněné kontextové menu." + 
                System.Environment.NewLine + 
                System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;

            temp = "1.4 Editace geometrických objektů" + System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;
            richtextbox.SelectionFont = new Font(richtextbox.Font, FontStyle.Bold);
            temp =
                "Pro editaci a prohlížení vlastností objektů slouží dialog, který se zobrazí po poklepání na editovaný objekt v seznamu objektů. Tento dialog umožňuje, aby mohl uživatel současně manipulovat s tímto dialogem a zároveň i s hlavním oknem programu. Tento dialog zobrazuje na několika stránkách všechny editovatelné vlastnosti objektu. Obsah tohoto dialogu závisí na typu objektu jehož vlastnosti chceme prohlížet nebo editovat. Tento dialog může obsahovat:"+
                System.Environment.NewLine +
                System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;

            temp =
                "1. stránku zobrazující rovnice objektu, "+ 
                System.Environment.NewLine +
                "2. stránku zobrazující vlastnosti roviny v níž je objekt definován,"+
                System.Environment.NewLine +
                "3. stránku zobrazující souřadnice středu objektu,"+
                System.Environment.NewLine +
                "4. stránku zobrazující informace o rotaci objektu,"+
                System.Environment.NewLine +
                "5. stránku zobrazující jméno, barvu, viditelnost objektu a viditelnost os objektu, " +
                System.Environment.NewLine +
                System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;

            temp =
                "Většinu zobrazených vlastností je možno buď přímo nebo otevřením editačního dialogu dané vlastnosti editovat. Editační dialog dané vlastnosti se zobrazí po klepnutí na tlačítko přidružené k dané vlastnosti. Editační dialogy vlastností umožňují aby mohl uživatel současně manipulovat s těmito dialogy i s hlavním oknem programu. V případě, že dojde k editaci takové vlastnosti objektu, která změní jeho tvar nebo pozici, jsou případné průniky s tímto objektem přepočítány."+
                System.Environment.NewLine + 
                System.Environment.NewLine +
                "Dialog upravující rotaci objektu se jako jediný odlišuje od ostatních dialogů tím, že se každá změna rotace ihned projeví na editovaném objektu, ale přitom informace o této akci není až do klepnutí na tlačítko OK do historie uložena. Navíc změna provedená v tomto editačním dialogu může ovlivnit obsah jiného dialogu. Kvůli složité synchronizaci těchto změn, je v jednu chvíli povoleno editovat pouze jednu vlastnost ovlivňující tvar nebo pozici objektu. Toto je zajištěno zakázáním daných tlačítek v okně detailu, otevírajících editační dialog. Ze stejného důvodu jsou zakázány akce vpřed a zpět v čase, kdy je otevřen libovolný dialog editace rotace. "+
                System.Environment.NewLine +
                System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;

            temp =
                "1.5 Historie" + System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;
            richtextbox.SelectionFont = new Font(richtextbox.Font, FontStyle.Bold);
            temp =
                "Program si pamatuje historii provedených akcí a umožňuje uživateli se v historii pohybovat. Přičemž do historie se zapisují pouze akce manipulující s grafickými objekty. Posun v historii o krok zpět provede klepnutím na položku Úpravy/Zpět ve standardním menu nebo stiskem kombinace kláves Ctrl+Z. Pro posun o krok vpřed klepneme na položku Úpravy/Vpřed ve standardním menu nebo stiskneme kombinaci kláves Ctrl+Y." +
                System.Environment.NewLine +
                System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;

            temp =
                "1.5 Uložení" + System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;
            richtextbox.SelectionFont = new Font(richtextbox.Font, FontStyle.Bold);
            temp =
                "Uložení obsahu scény provedeme klepnutím na položku Soubor/Uložit ve standardním menu nebo stiskem kombinace kláves Ctrl+S. Následně se zobrazí standardní dialog pro uložení souboru, ve kterém vybereme umístění ukládaného souboru a specifikujeme jeho název."+
                System.Environment.NewLine +
                System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;

            temp =
                "1.6 Načtení" + System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;
            richtextbox.SelectionFont = new Font(richtextbox.Font, FontStyle.Bold);
            temp =
                "Načtení uložené scény provedeme klepnutím na položku Soubor/Načíst ve standardním menu nebo stiskem kombinace kláves Ctrl+O. Poté se program zeptá na potvrzení této volby a nabídne uložení stávající scény. Dojde-li k chybě během ukládání, je akce načítání stornována. Po úspěšném uložení nebo  po přeskočení uložení se zobrazí standardní dialog pro otevření souboru. Dojde-li k chybě během načítání nové scény, zůstane aktivní stávající scéna."+
                System.Environment.NewLine +
                System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;

            temp =
                "1.7 Nová scéna" + System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;
            richtextbox.SelectionFont = new Font(richtextbox.Font, FontStyle.Bold);
            temp =
                "Resetování scény provedeme klepnutím na položku Soubor/Nový ve standardním menu nebo stiskem kombinace kláves Ctrl+N. Poté se program zeptá na potvrzení této volby a nabídne uložení stávající scény. Dojde-li k chybě během ukládání, je akce resetování stornována." +
                System.Environment.NewLine +
                System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;

            temp = "1.8 Export do obrázku" + System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;
            richtextbox.SelectionFont = new Font(richtextbox.Font, FontStyle.Bold);
            temp =
                "Export do obrázku provedeme klepnutím na položku Soubor/Export do obrázku ve standardním menu nebo stiskem kombinace kláves Ctrl+E. Následně se zobrazí standardní dialog pro uložení souboru, ve kterém vybereme umístění ukládaného souboru a specifikujeme jeho název."+
                System.Environment.NewLine +
                System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;

            temp = "1.9 Nastavení" + System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;
            richtextbox.SelectionFont = new Font(richtextbox.Font, FontStyle.Bold);
            temp =
                "Uživateli je umožněno změnit několik vybraných grafických vlastností, kterými jsou" +
                System.Environment.NewLine +
                System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;

            temp =
    "1. Kvalita objektů - v zobrazeném dialogu lze nastavit přesnost aproximace křivek a ploch, " +
    System.Environment.NewLine +
    "2. Barva pozadí - v zobrazeném dialogu lze nastavit barvu pozadí scény," +
    System.Environment.NewLine +
    "3. Vyplnit plochy - po klepnutí na tuto položku bude trojúhelníková síť ploch vyplněna barvou," +
    System.Environment.NewLine +
    "4. Trojúhelníková síť - po klepnutí na tuto položku budou plochy kresleny jako trojúhelníkové sítě," +
    System.Environment.NewLine +
    "5. Antialiasing - klepnutím na tuto položku se zobrazí následující kategorie menu, ve které lze klepnutím nastavit úroveň antialiasingu. Nepodporované úrovně antialiasingu jsou nedostupné." +
    System.Environment.NewLine +
    System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;

            temp = "2.0 Uživatelská nápověda" + System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;
            richtextbox.SelectionFont = new Font(richtextbox.Font, FontStyle.Bold);
            temp =
                "Zobrazení nápovědy provedeme klepnutím na položku Nápověda/Zobrazit nápovědu ve standardním menu nebo stisknutím kombinace kláves Ctrl+H." +
                System.Environment.NewLine +
                System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;

            temp = "2.1 Ukončení programu" + System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;
            richtextbox.SelectionFont = new Font(richtextbox.Font, FontStyle.Bold);
            temp =
                "Ukončení programu provedeme uzavřením hlavního okna programu libovolným ze standardních způsobů. Jimi jsou klepnutí na uzavírací tlačítko v pravém horním rohu okna, stisk kombinace kláves it Alt+F4 nebo klepnutí na položku Soubor/Ukončit ve standardním menu. Poté se program zeptá na potvrzení této volby a nabídne uložení stávající scény. Dojde-li k chybě během ukládání, je akce ukončení stornována." +
                System.Environment.NewLine +
                System.Environment.NewLine;
            richTextBoxLength = richtextbox.Text.Length;
            richtextbox.AppendText(temp);
            richtextbox.Select(richTextBoxLength, richtextbox.Text.Length - richTextBoxLength);
            richtextbox.SelectionAlignment = HorizontalAlignment.Left;

            temp = System.Environment.NewLine + System.Environment.NewLine + System.Environment.NewLine + System.Environment.NewLine;
            richtextbox.AppendText(temp);  

            richtextbox.Select(0,0);

            //this.Controls.Add(upPanel);
            this.Controls.Add(bottomPanel);
            //upPanel.BackColor = SystemColors.ControlDark;
            bottomPanel.BackColor = SystemColors.ControlLight;
            //this.BackColor = System.Drawing.Color.White;

            this.Controls.Add(richtextbox);
        }

        private void HelpForm_Resize(object sender, EventArgs e)
        {
            richtextbox.RightMargin = this.ClientSize.Width - 2 * distanceFromText - scrollBar.Width;
            bottomPanel.Size = new Size(this.ClientSize.Width, 10);
            bottomPanel.Location = new Point(0, this.ClientSize.Height -10);
        }
    }
}
