﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Geometry.BaseClasses;

namespace Geometry
{
    public partial class Settings : Form
    {
        private Form1 _form;
        private BaseQuality _previousQuality;
 
        public Settings(Form1 form)
        {
            InitializeComponent();
            _form = form;
            _previousQuality = form.GetScene().GetBaseQuality();
            SetRadioButton(_previousQuality);
            this.radioButtonLOW.CheckedChanged += new System.EventHandler(this.radioButton_CheckedChanged);
            this.radioButtonMEDIUM.CheckedChanged += new System.EventHandler(this.radioButton_CheckedChanged);
            this.radioButtonHIGH.CheckedChanged += new System.EventHandler(this.radioButton_CheckedChanged);            
            this.radioButtonVERYHIGH.CheckedChanged += new System.EventHandler(this.radioButton_CheckedChanged);
        }

        private void SetRadioButton(BaseQuality quality) 
        {
            switch (quality.ToInt()) 
            {
                case (int)BaseQuality.BaseEnum.LOW: radioButtonLOW.Checked = true; break;
                case (int)BaseQuality.BaseEnum.MEDIUM: radioButtonMEDIUM.Checked = true; break;
                case (int)BaseQuality.BaseEnum.HIGH: radioButtonHIGH.Checked = true; break;
                case (int)BaseQuality.BaseEnum.VERYHIGH: radioButtonVERYHIGH.Checked = true; break; 
                default: throw new Exception("Tato situace je neocekavana.");
            }
        }

        // deset urovni detailu.
        private void buttonOK_Click(object sender, EventArgs e)
        {
            Close();
        }
        private void buttonStorno_Click(object sender, EventArgs e)
        {
            SetQuality(_previousQuality);
            Close();
        }


        private void SetQuality(BaseQuality quality) 
        {
            this.Cursor = Cursors.WaitCursor; 
            _form.GetManipulation().SetObjectsQualityInvoked(quality);
            this.Cursor = Cursors.Default;       
        }

        private void radioButton_CheckedChanged(object sender, EventArgs e) 
        {
            if (radioButtonLOW.Checked)
                SetQuality(new BaseQuality(BaseQuality.BaseEnum.LOW));
            if (radioButtonMEDIUM.Checked)
                SetQuality(new BaseQuality(BaseQuality.BaseEnum.MEDIUM));
            if (radioButtonHIGH.Checked)
                SetQuality(new BaseQuality(BaseQuality.BaseEnum.HIGH));
            if (radioButtonVERYHIGH.Checked)
                SetQuality(new BaseQuality(BaseQuality.BaseEnum.VERYHIGH));
        }
    }
}
