﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry;

namespace GMath
{
    public class RotationAngles
    {
        private double _xAngle;
        private double _yAngle;
        private double _zAngle;

        public RotationAngles(double xAngle, double yAngle, double zAngle) 
        {
            _xAngle = xAngle;
            _yAngle = yAngle;
            _zAngle = zAngle;
        }

        public double GetXAngle() { return _xAngle; }

        public double GetYAngle() { return _yAngle; }

        public double GetZAngle() { return _zAngle; }

        public void SetXAngle(double angle) { _xAngle = angle; }

        public void SetYAngle(double angle) { _yAngle = angle; }

        public void SetZAngle(double angle) { _zAngle = angle; }

        public static RotationAngles operator -(RotationAngles a, RotationAngles b) 
        {
            return new RotationAngles(
                a._xAngle - b._xAngle, 
                a._yAngle - b._yAngle, 
                a._zAngle - b._zAngle);
        }

        public static bool Equal(RotationAngles a, RotationAngles b) 
        {
            return Program.IsEqualInToleranceIntersection(a._xAngle, b._xAngle) &&
                Program.IsEqualInToleranceIntersection(a._yAngle, b._yAngle) &&
                Program.IsEqualInToleranceIntersection(a._zAngle, b._zAngle);
        }
    }
}
