﻿
namespace GMath
{
    public class ComplicatedEquationMember
    {
        private double _constant;
        private string _variables;

        public ComplicatedEquationMember(double constant, string variables) 
        {
            _constant = constant;
            _variables = Sort(variables);
        }

        public string GetVariables() { return _variables; }

        private string Sort(string variables) 
        {
            char temp;
            char[] variablesAsArray = variables.ToCharArray();
            int j;
            for (int i = 1; i < variables.Length; i++)
            {
                temp = variablesAsArray[i];
                for (j = i - 1; j < 0; j--)
                {
                    if (variablesAsArray[i] < variablesAsArray[j])
                        variablesAsArray[j + 1] = variablesAsArray[j];
                }
                variablesAsArray[j] = temp;
            }
            return variablesAsArray.ToString();
        }

        private string Merge(string variablesA, string variablesB) 
        {
            int aLength = variablesA.Length;
            int bLength = variablesB.Length;
            int aIndex = 0;
            int bIndex = 0;
            string retval = "";

            for (int i = 0; i < aLength + bLength; i++) 
            {
                if (variablesA[aIndex] < variablesB[bIndex] && aIndex < aLength || bIndex < bLength)
                    retval += variablesA[aIndex++];
                else retval += variablesB[bIndex++];                
            }
            return retval;
        }

        public static ComplicatedEquationMember operator *(ComplicatedEquationMember a, ComplicatedEquationMember b) 
        {
            return new ComplicatedEquationMember(a._constant * b._constant, a.Merge(a._variables, b._variables));
        }

        public static ComplicatedEquationMember operator +(ComplicatedEquationMember a, ComplicatedEquationMember b) 
        {
            return new ComplicatedEquationMember(a._constant + b._constant, a._variables);
        }
    }
}
