﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GMath;

namespace GMath
{
    class ComplexLinearEquation:IComplexEquation
    {
        private Complex _a;
        private Complex _b;

        public ComplexLinearEquation(Complex a, Complex b) 
        {
            _a = a;
            _b = b;
        }

        public override Complex Substitute(Complex root)
        {
            return _a * root + _b;
        }
        public override double Substitute(double root)
        {
            return (_a * root + _b)._z;
        }

        ////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////

        public override List<List<Complex>> SolveGetAllSetsOfRoots()
        {
            if (_a._z == 0)
            {
                return new List<List<Complex>>();
            }
            return new List<List<Complex>>() { new List<Complex>() { -_b / _a, } };
        }

        ////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////

        protected override List<Complex> GetListOfKoeficientsComplex()
        {
            return new List<Complex>() { new Complex(_a), new Complex(_b) };
        }
    }
}
