﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GMath
{
    public class ConicCharacteristicEquation:QuadraticEquation
    {
        public ConicCharacteristicEquation(double a, double b, double c)
            : base(a, b, c)
        {

        }

        /// <summary>
        /// Řešení charakteristického polynomu kvadriky jsou vždy 3.
        /// </summary>
        /// <returns></returns>
        public override List<double> Solve()
        {
            List<List<Complex>> complexRoots = SolveGetAllSetsOfRoots();
            for (int i = complexRoots.Count - 1; i >= 0; i--)
                if (complexRoots[i].Count != 2)
                    complexRoots.RemoveAt(i);

            List<Complex> roots = GetTheRootsFromSetOfRoots(complexRoots);
            List<double> realRoots = new List<double>();
            foreach (Complex c in roots)
                realRoots.Add(c._real);
            return realRoots;
        }
    }
}
