﻿using Geometry.GraphicObjects.Matrixes;
using Geometry.GraphicObjects.Equations;
using Geometry.BaseClasses;
using GMath;

namespace Geometry.GraphicObjects.ConicSections
{
    public class ImaginarParallelLines : ConicSection
    {
        private double _a;

        public static string canonicFormatString = "E[x-!m;!a]L[= -1]";
        public static string parametricXFormatString = "L[x = " + U.EmptySet + "]";
        public static string parametricYFormatString = "L[y = " + U.EmptySet + "]";

        public static string _wordDescriptionFirstCase = "Imaginární rovnoběžné přímky";
        public static string _wordDescriptionSecondCase = "Imaginárních ronoběžných přímek";
        public static string _wordDescriptionFourthCase = "Imaginární rovnoběžné přímky";

        public ImaginarParallelLines(ConicEquation commonEquation, ParametricEquation parametricEquation,
            TransformationMatrix toCanonicTransformationMatrix,
            GColor color, string name, int ID)
            : base(commonEquation, parametricEquation, toCanonicTransformationMatrix,
            color, name,
            _wordDescriptionFirstCase, _wordDescriptionSecondCase, _wordDescriptionFourthCase,
            canonicFormatString, parametricXFormatString, parametricYFormatString, ID)
        {
            _a = parametricEquation.GetA();
        }

        protected override void BuildParametricDisplayList(Scene scene, RelativeQuality relativeQuality) 
        {
        }


        protected override ConicSection CallConstructor(ConicEquation commonEquation, ParametricEquation parametricEquation,
            TransformationMatrix toCanonicTransformationMatrix, GColor color, string name, int ID)
        {
            return new ImaginarParallelLines(commonEquation, parametricEquation, toCanonicTransformationMatrix, color, name, ID);
        }


        public override ConicMatrix GetCanonicMatrix()
        {
            double A = -1 / (_parametricEquation.GetA() * _parametricEquation.GetA());
            ConicEquation newCanonicEquation = new ConicEquation(A, 0, 0, 0, 0, -1);
            return new ConicMatrix(newCanonicEquation);
        }
    }
}
