﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Tao.OpenGl;
using Geometry.BaseClasses;
using Geometry.GraphicObjects.ConicSections;

namespace Geometry.GraphicObjects.Intersections
{
    public class ConicAndConicIntersection:IIntersection
    {

        public ConicAndConicIntersection(ConicSection conicA, ConicSection conicB,
            List<GraphicObject> intersections, GColor color, string name, int ID)
            : base(conicA, conicB, intersections, color, name, ID)
        {
        }

        public override IIntersection RecomputeIntersection
            (Scene scene, GraphicObject objectA, GraphicObject objectB, int newID)
        {
            ConicSection conicA = (ConicSection)objectA;
            ConicSection conicB = (ConicSection)objectB;

            ConicAndConicIntersectionRecognizer ir =
                new ConicAndConicIntersectionRecognizer(conicA, conicB, _color, _name, newID);
            return ir.GetIntersection();
        }
    }
}
