﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects;
using Geometry.GraphicObjects.Planar;
using Geometry.GraphicObjects.ConicSections;

namespace Geometry.GraphicObjects.Intersections
{
    class ConicAndLineIntersection:IIntersection
    {

        public ConicAndLineIntersection(ConicSection conic, Line line, List<GraphicObject> intersections,
            GColor color, string name, int ID)
            : base(conic, line, intersections, color, name, ID) 
        {
        }


        public override IIntersection RecomputeIntersection
            (Scene scene, GraphicObject objectA, GraphicObject objectB, int newID)
        {

            ConicSection conicSection;
            Line line;
            if (objectA is ConicSection)
            {
                conicSection = (ConicSection)objectA;
                line = (Line)objectB;
            }
            else 
            {
                line = (Line)objectA;
                conicSection = (ConicSection)objectB;
            }
            ConicAndLineIntersectionRecognizer ir =
                new ConicAndLineIntersectionRecognizer(conicSection, line, _color, _name, newID);
            return ir.GetIntersection();
        }
    }
}
