﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects.Planar;
using Geometry.GraphicObjects.ConicSections;

namespace Geometry.GraphicObjects.Intersections
{
    class ConicAndPlanIntersection:IIntersection
    {

         public ConicAndPlanIntersection(ConicSection conic, Plan plan, List<GraphicObject> intersections,
            GColor color, string name, int ID)
            : base(conic, plan,intersections, color, name, ID) 
        { 
        }


        public override IIntersection RecomputeIntersection
            (Scene scene, GraphicObject objectA, GraphicObject objectB, int newID)
        {

            ConicSection conicSection;
            Plan plan;
            if (objectA is ConicSection)
            {
                conicSection = (ConicSection)objectA;
                plan = (Plan)objectB;
            }
            else 
            {
                plan = (Plan)objectA;
                conicSection = (ConicSection)objectB;
            }
            ConicAndPlanIntersectionRecognizer ir =
                new ConicAndPlanIntersectionRecognizer(conicSection, plan, _color, _name, newID);
            return ir.GetIntersection();
        }
    }
}
