﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects;
using Geometry.GraphicObjects.Planar;
using Geometry.GraphicObjects.ConicSections;

namespace Geometry.GraphicObjects.Intersections
{
    public class ConicAndPointIntersection:IIntersection
    {
        public ConicAndPointIntersection(ConicSection conic, GPoint point, List<GraphicObject> intersections,
            GColor color, string name, int ID)
            : base(conic, point, intersections, color, name, ID)
        { }



        public override IIntersection RecomputeIntersection
            (Scene scene, GraphicObject objectA, GraphicObject objectB, int newID)
        {
            ConicSection conicSection;
            GPoint point;
            if (objectA is ConicSection)
            {
                conicSection = (ConicSection)objectA;
                point = (GPoint)objectB;
            }
            else
            {
                point = (GPoint)objectA;
                conicSection = (ConicSection)objectB;
            }
            ConicAndPointIntersectionRecognizer ir =
                new ConicAndPointIntersectionRecognizer(conicSection, point, _color, _name, newID);
            return ir.GetIntersection();
        }
    }
}
