﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects;
using Geometry.GraphicObjects.Planar;

namespace Geometry.GraphicObjects.Intersections
{
    public class LineAndPointIntersection:IIntersection
    {

        public LineAndPointIntersection(Line line, GPoint point, List<GraphicObject> intersections,
            GColor color, string name, int ID)
            :base(line, point, intersections, color, name, ID)
        { }

        public override IIntersection RecomputeIntersection(
            Scene scene, GraphicObject objectA, GraphicObject objectB, int newID)
        {
            Line line;
            GPoint point;
            if (objectA is Line)
            {
                line = (Line)objectA;
                point = (GPoint)objectB;
            }
            else
            {
                point = (GPoint)objectA;
                line = (Line)objectB;
            }
            LineAndPointIntersectionRecognizer ir =
                new LineAndPointIntersectionRecognizer(line, point, _color, _name, newID);
            return ir.GetIntersection();
        }
    }
}
