﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects.Planar;

namespace Geometry.GraphicObjects.Intersections
{
    public class PlanAndLineIntersection:IIntersection
    {

        public PlanAndLineIntersection(GraphicObject objectA, GraphicObject objectB, GraphicObject intersections,
            GColor color, string name, int ID)
            : base(objectA, objectB, new List<GraphicObject>() {intersections}, color, name, ID) 
        {
        }


        public override IIntersection RecomputeIntersection
            (Scene scene, GraphicObject objectA, GraphicObject objectB, int newID)
        {

            Plan plan;
            Line line;
            if (objectA is Plan)
            {
                plan = (Plan)objectA;
                line = (Line)objectB;
            }
            else
            {
                line = (Line)objectA;
                plan = (Plan)objectB;
            }
            PlanAndLineIntersectionRecognizer ir =
                new PlanAndLineIntersectionRecognizer(plan, line, _color, _name, newID);
            return ir.GetIntersection();
        }
    }
}
