﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects.Planar;

namespace Geometry.GraphicObjects.Intersections
{
    public class PlanAndPlanIntersection:IIntersection
    {

        public PlanAndPlanIntersection(GraphicObject objectA, GraphicObject objectB, GraphicObject intersections,
            GColor color, string name, int ID)
            : base(objectA, objectB, new List<GraphicObject>() { intersections }, color, name, ID)
        {
        }


        public override IIntersection RecomputeIntersection
           (Scene scene, GraphicObject objectA, GraphicObject objectB, int newID)
        {
            Plan planA = (Plan)objectA;
            Plan planB = (Plan)objectB;

            PlanAndPlanIntersectionRecognizer ir =
                new PlanAndPlanIntersectionRecognizer(planA, planB, _color, _name, newID);
            return ir.GetIntersection();
        }
    }
}