﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects;
using Geometry.GraphicObjects.Planar;

namespace Geometry.GraphicObjects.Intersections
{
    public class PlanAndPointIntersection:IIntersection
    {
        public PlanAndPointIntersection(Plan plan, GPoint point, List<GraphicObject> intersections,
            GColor color, string name, int ID):base (plan, point, intersections, color, name, ID) 
        { }



        public override IIntersection RecomputeIntersection
            (Scene scene, GraphicObject objectA, GraphicObject objectB, int newID)
        {
            Plan plan;
            GPoint point;
            if (objectA is Plan)
            {
                plan = (Plan)objectA;
                point = (GPoint)objectB;
            }
            else
            {
                point = (GPoint)objectA;
                plan = (Plan)objectB;
            }
            PlanAndPointIntersectionRecognizer ir =
                new PlanAndPointIntersectionRecognizer(plan, point, _color, _name, newID);
            return ir.GetIntersection();
        }
    }
}
