﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects.Planar;

namespace Geometry.GraphicObjects.Intersections
{
    class PlanAndPointIntersectionRecognizer
    {
        private Plan _plan;
        private GPoint _point;
        private GColor _color;
        private string _name;
        private int _ID;

        public PlanAndPointIntersectionRecognizer(Plan plan, GPoint point, GColor color, string name, int ID)
        {
            _plan = plan;
            _point = point;
            _color = color;
            _name = name;
            _ID = ID;
        }

        public PlanAndPointIntersection GetIntersection() 
        {
            PointAndWithCommonEquationObjectIntersectionRecognizer ir =
                new PointAndWithCommonEquationObjectIntersectionRecognizer(_plan, _point, _color, _name, _ID);
            PointAndWithCommonEquationObjectIntersection semiIntersection = ir.GetIntersection();
            return new PlanAndPointIntersection(
                _plan, _point, semiIntersection.GetIntersections(), _color, _name, _ID);
        }
    }
}
