﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects.Planar;

namespace Geometry.GraphicObjects.Intersections
{
    public class PointAndPointIntersection:IIntersection
    {

        public PointAndPointIntersection(GPoint pointA, GPoint pointB,
            List<GraphicObject> intersections, GColor color, string name, int ID)
            : base(pointA, pointB, intersections, color, name, ID)
        {
        }

        public override IIntersection RecomputeIntersection
            (Scene scene, GraphicObject objectA, GraphicObject objectB, int newID)
        {
            GPoint pointA = (GPoint)objectA;
            GPoint pointB = (GPoint)objectB;

            PointAndPointIntersectionRecognizer ir =
                new PointAndPointIntersectionRecognizer(pointA, pointB, _color, _name, _ID);
            return ir.GetIntersection();
        }
    }
}
