﻿using System.Collections.Generic;
using Geometry.GraphicObjects.Planar;
using GMath;


namespace Geometry.GraphicObjects.Intersections
{
    public class PointAndPointIntersectionRecognizer
    {
        private GPoint _pointA;
        private GPoint _pointB;
        private GColor _color;
        private string _name;
        private int _ID;

        public PointAndPointIntersectionRecognizer(GPoint pointA, GPoint pointB, GColor color, string name, int ID)
        {
            _pointA = pointA;
            _pointB = pointB;
            _color = color;
            _name = name;
            _ID = ID;
        }

        /// <summary>
        /// Tri moznosti bud jsou primky totozne nebo se protinaji, nebo jsou mimobezne.
        /// </summary>
        /// <returns></returns>
        public PointAndPointIntersection GetIntersection() 
        {
            Vector pointACoordinates = _pointA.GetCenterInStandardBasis().GetReprezentant();
            Vector pointBCoordinates = _pointB.GetCenterInStandardBasis().GetReprezentant();
            GraphicObject intersection;
            if (Vector.AreEqualInTolerance(pointACoordinates, pointBCoordinates))
                intersection = _pointA.MakeCopyOfObject(_pointA.GetID());
            else intersection = new EmptyIntersection();
            return new PointAndPointIntersection(
                _pointA, _pointB, new List<GraphicObject>() { intersection }, _color, _name, _ID);
        }
    }
}
