﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects;
using Geometry.GraphicObjects.Planar;

namespace Geometry.GraphicObjects.Intersections
{
    public class PointAndWithCommonEquationObjectIntersection:IIntersection
    {
        public PointAndWithCommonEquationObjectIntersection(
            WithCommonEquationObject withCommonEquationObject, GPoint point, List<GraphicObject> intersections,
            GColor color, string name, int ID)
            : base(withCommonEquationObject, point, intersections, color, name, ID)
        { }


        public override IIntersection RecomputeIntersection
            (Scene scene, GraphicObject objectA, GraphicObject objectB, int newID)
        {
            WithCommonEquationObject withCommonEquationObject;
            GPoint point;
            if (objectA is WithCommonEquationObject)
            {
                withCommonEquationObject = (WithCommonEquationObject)objectA;
                point = (GPoint)objectB;
            }
            else
            {
                point = (GPoint)objectA;
                withCommonEquationObject = (WithCommonEquationObject)objectB;
            }
            PointAndWithCommonEquationObjectIntersectionRecognizer ir =
                new PointAndWithCommonEquationObjectIntersectionRecognizer(
                    withCommonEquationObject, point, _color, _name, newID);
            return ir.GetIntersection();

        }
    }
}
