﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects;
using Geometry.GraphicObjects.Quadrics;
using Geometry.GraphicObjects.ConicSections;

namespace Geometry.GraphicObjects.Intersections
{
    class QuadricAndConicIntersection:IIntersection
    {

        public QuadricAndConicIntersection(Quadric quadric, ConicSection conic, List<GraphicObject> intersections,
            GColor color, string name, int ID)
            : base(quadric, conic, intersections, color, name, ID) 
        {
            _intersections = intersections; 
        }


        public override IIntersection RecomputeIntersection
            (Scene scene, GraphicObject objectA, GraphicObject objectB, int newID)
        {

            Quadric quadric;
            ConicSection conicSection;
            if (objectA is ConicSection)
            {
                conicSection = (ConicSection)objectA;
                quadric = (Quadric)objectB;
            }
            else 
            {
                quadric = (Quadric)objectA;
                conicSection = (ConicSection)objectB;
            }
            QuadricAndConicIntersectioRecognizer ir =
                new QuadricAndConicIntersectioRecognizer(quadric, conicSection, _color, _name, newID);
            return ir.GetIntersection();
        }
    }
}
