﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects.Quadrics;
using Geometry.GraphicObjects.Planar;


namespace Geometry.GraphicObjects.Intersections
{
    public class QuadricAndLineIntersection:IIntersection
    {

        public QuadricAndLineIntersection(GraphicObject objectA, GraphicObject objectB, List<GraphicObject> intersections,
            GColor color, string name, int ID)
            : base(objectA, objectB,intersections, color, name, ID) 
        {
        }
        public override IIntersection RecomputeIntersection
            (Scene scene, GraphicObject objectA, GraphicObject objectB, int newID)
        {

            Quadric quadric;
            Line line;
            if (objectA is Quadric)
            {
                quadric = (Quadric)objectA;
                line = (Line)objectB;
            }
            else
            {
                line = (Line)objectA;
                quadric = (Quadric)objectB;
            }
            QuadricAndLineIntersectionRecognizer ir =
                new QuadricAndLineIntersectionRecognizer(quadric, line, _color, _name, newID);
            return ir.GetIntersection();
        }
    }
}
