﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects;
using Geometry.GraphicObjects.ConicSections;
using Geometry.GraphicObjects.Planar;
using Geometry.GraphicObjects.Quadrics;

namespace Geometry.GraphicObjects.Intersections
{
    /// <summary>
    /// Průnikem je buď kuželosečka, ta rovina, přímka nebo prázdná množina.
    /// </summary>
    public class QuadricAndPlanIntersection:IIntersection
    {

        public QuadricAndPlanIntersection(Quadric quadric, Plan plan, GraphicObject intersections,
            GColor color, string name, int ID)
            :base(quadric, plan,new List<GraphicObject>(){intersections}, color, name, ID) 
        {
        }


        public override IIntersection RecomputeIntersection
            (Scene scene, GraphicObject objectA, GraphicObject objectB, int newID)
        {

            Quadric quadric;
            Plan plan;
            if (objectA is Quadric)
            {
                quadric = (Quadric)objectA;
                plan = (Plan)objectB;
            }
            else 
            {
                plan = (Plan)objectA;
                quadric = (Quadric)objectB;
            }
            QuadricAndPlanItersectionRecognizer ir =
                new QuadricAndPlanItersectionRecognizer(quadric, plan, _color, _name, newID);
            return ir.GetIntersection();
        }
    }
}
