﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects;
using Geometry.GraphicObjects.Quadrics;
using Geometry.GraphicObjects.Planar;
using Geometry.GraphicObjects.Equations;
using Geometry.GraphicObjects.Intersections;

namespace Geometry.GraphicObjects.Intersections
{
    public class QuadricAndPointIntersectionRecognizer
    {
        private Quadric _quadric;
        private GPoint _point;
        private GColor _color;
        private string _name;
        private int _ID;

        public QuadricAndPointIntersectionRecognizer(Quadric quadric, GPoint point, GColor color, string name, int ID)
        {
            _quadric = quadric;
            _point = point;
            _color = color;
            _name = name;
            _ID = ID;
        }

        public QuadricAndPointIntersection GetIntersection() 
        {
            PointAndWithCommonEquationObjectIntersectionRecognizer ir =
                new PointAndWithCommonEquationObjectIntersectionRecognizer(_quadric, _point, _color, _name, _ID);
            PointAndWithCommonEquationObjectIntersection semiIntersection = ir.GetIntersection();
            return new QuadricAndPointIntersection(
                _quadric, _point, semiIntersection.GetIntersections(), _color, _name, _ID);

        }
    }
}
