﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects.Planar;
using Geometry.GraphicObjects.Quadrics;

namespace Geometry.GraphicObjects.Intersections
{
    public class QuadricAndPointIntersection:IIntersection
    {
        public QuadricAndPointIntersection(Quadric quadric, GPoint point, List<GraphicObject> intersections,
            GColor color, string name, int ID):base (quadric, point, intersections, color, name, ID) 
        { }



        public override IIntersection RecomputeIntersection
            (Scene scene, GraphicObject objectA, GraphicObject objectB, int newID)
        {
            Quadric quadric;
            GPoint point;
            if (objectA is Quadric)
            {
                quadric = (Quadric)objectA;
                point = (GPoint)objectB;
            }
            else
            {
                point = (GPoint)objectA;
                quadric = (Quadric)objectB;
            }
            QuadricAndPointIntersectionRecognizer ir =
                new QuadricAndPointIntersectionRecognizer(quadric, point, _color, _name, newID);
            return ir.GetIntersection();
        }
    }
}
