﻿using System.Collections.Generic;
using GMath;

namespace Geometry.GraphicObjects.Intersections
{
    public class DefinitionInterval
    {
        private List<Interval> _intervals;
        private List<double> _plusValues = new List<double>();
        private List<double> _minusValues = new List<double>();

        public DefinitionInterval(Interval interval) 
        {
            _intervals = new List<Interval>() { interval };
        }

        public DefinitionInterval(List<Interval> intevals)
        {
            _intervals = intevals; 
        }
        public DefinitionInterval(List<Interval> intevals, List<double> minusValues)
        {
            _intervals = intevals;
            _minusValues = minusValues;
        }
        public DefinitionInterval(Interval inteval, List<double> minusValues)
        {
            _intervals = new List<Interval>() { inteval };
            _minusValues = minusValues;
        }
        public DefinitionInterval(List<Interval> intevals, List<double> plusValues, List<double> minusValues) 
        {
            _intervals = intevals;
            _plusValues = plusValues;
            _minusValues = minusValues;
        }


        public List<Interval> GetIntervals() { return _intervals; }
        public List<double> GetPlusValues() { return _plusValues; }
        public List<double> GetMinusValues() { return _minusValues; }

        internal void Sort()
        {
            _intervals = Interval.SortIntervals(_intervals);
        }
    }
}
