﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Tao.OpenGl;
using Geometry.GraphicObjects.Quadrics;
using Geometry.GraphicObjects; 
using Geometry.BaseClasses;

namespace Geometry.GraphicObjects.Intersections
{
    public class QuadricAndQuadricIntersection:IIntersection
    {
        private SimpleRulledQuadric _simpleRulled;

        public QuadricAndQuadricIntersection(Quadric quadricA, Quadric quadricB, SimpleRulledQuadric simpleRuled,
            List<GraphicObject> sections, GColor color, string name, int ID)
            :base(quadricA, quadricB, sections, color, name, ID)
        {
            this._simpleRulled = simpleRuled; 
        }



        public override IIntersection RecomputeIntersection
            (Scene scene, GraphicObject objectA, GraphicObject objectB, int newID)
        {
            //return this;
            QuadricAndQuadricIntersectionRecognizer ir = 
                new QuadricAndQuadricIntersectionRecognizer((Quadric)objectA, (Quadric)objectB, _color, _name, newID);
            return ir.GetIntersection();
        }


        public SimpleRulledQuadric GetSimpleRulled()
        {
            return _simpleRulled;
        }
  }
}
