﻿using GMath;

namespace Geometry.GraphicObjects.Equations
{
    /// <summary>
    /// Nese informaci o koeficientech kanonicke/parametricke rovnice objektu.
    /// Nese infomaci i o parametrizaci stredu objektu.
    /// Pokud je objekt s kanonickym tvarem, pak je parametrizace v kanonicke bazi.
    /// Pokud je objeky jen s parametrickym tvarem, pak je parametrizace ve standardni bazi.
    /// </summary>
    public class KoefsAndCenterPair
    {
        private ParametricEquation _parametricEquation;
        private CenterParametrization _centerParametrization;


        public KoefsAndCenterPair(ParametricEquation parametricEquation, CenterParametrization centerParametrization)
        {
            _parametricEquation = parametricEquation;
            _centerParametrization = centerParametrization;
        }

        public static bool AreEqualInTolerance(KoefsAndCenterPair a, KoefsAndCenterPair b) 
        {
            return ParametricEquation.AreEqualInTolerance(a.GetParametricEquation(), b.GetParametricEquation()) &&
                CenterParametrization.AreEqualInTolerance(a.GetCenterParametrization(), b.GetCenterParametrization());
        }

        public ParametricEquation GetParametricEquation() { return _parametricEquation; }

        public CenterParametrization GetCenterParametrization() { return _centerParametrization; }

    }
}
