﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Geometry.GraphicObjects.Equations
{
    public class ConicParametricEquation:ParametricEquation
    {
        public ConicParametricEquation(ConicParametricEquation src) 
        {
            _values = base.CopyValues(src);
        }

        public ConicParametricEquation(double A, double B, double P)
        {
            _values = new List<double>() { A, B, P };
        }

        public override double GetA() { return _values[0]; }
        public override double GetB() { return _values[1]; }
        public override double GetP() { return _values[2]; }

        //public override double GetM() { return _values[3]; }
        //public override double GetN() { return _values[4]; }
        //public override double GetO() { return _values[5]; }

        public override double GetC() { throw new Exception("Invalid coeficient wanted."); }
        public override double GetUx() { throw new Exception("Invalid coeficient wanted."); }
        public override double GetUy() { throw new Exception("Invalid coeficient wanted."); }
        public override double GetUz() { throw new Exception("Invalid coeficient wanted."); }
        public override double GetVx() { throw new Exception("Invalid coeficient wanted."); }
        public override double GetVy() { throw new Exception("Invalid coeficient wanted."); }
        public override double GetVz() { throw new Exception("Invalid coeficient wanted."); }

        public override void SetA(double value) { _values[0] = value; }
        public override void SetB(double value) { _values[1] = value; }
        public override void SetP(double value) { _values[2] = value; }

        //public override void SetM(double value) { _values[3] = value; }
        //public override void SetN(double value) { _values[4] = value; }
        //public override void SetO(double value) { _values[5] = value; }

        public override void SetC(double value) { throw new Exception("Invalid coeficient setting."); }
        public override void SetUx(double value) { throw new Exception("Invalid coeficient setting."); }
        public override void SetUy(double value) { throw new Exception("Invalid coeficient setting."); }
        public override void SetUz(double value) { throw new Exception("Invalid coeficient setting."); }
        public override void SetVx(double value) { throw new Exception("Invalid coeficient setting."); }
        public override void SetVy(double value) { throw new Exception("Invalid coeficient setting."); }
        public override void SetVz(double value) { throw new Exception("Invalid coeficient setting."); }
    }
}
