﻿using System;
using System.Collections.Generic;
using GMath;

namespace Geometry.GraphicObjects.Equations
{
    public class LineParametricEquation:ParametricEquation
    {

        public LineParametricEquation(LineParametricEquation src) 
        {
            _values = base.CopyValues(src);
        }

        public LineParametricEquation(List<double> values) 
        {
            if (values.Count != 3)
                throw new ArgumentException();
            _values = values;
        }

        public LineParametricEquation(double Ux, double Uy, double Uz)
        {
            _values = new List<double>() { Ux, Uy, Uz};
        }

        public Vector Substitute(double t) 
        {
            double x = GetUx() * t;
            double y = GetUy() * t;
            double z = GetUz() * t;
            return new Vector(x, y, z);
        }

        public override double GetA() { throw new Exception("Invalid coeficient wanted."); }
        public override double GetB() { throw new Exception("Invalid coeficient wanted."); }
        public override double GetC() { throw new Exception("Invalid coeficient wanted."); }
        public override double GetP() { throw new Exception("Invalid coeficient wanted."); }

        //public override double GetM() { return _values[3]; }
        //public override double GetN() { return _values[4]; }
        //public override double GetO() { return _values[5]; }

        public override double GetUx() { return _values[0]; }
        public override double GetUy() { return _values[1]; }
        public override double GetUz() { return _values[2]; }
        public override double GetVx() { throw new Exception("Invalid coeficient wanted."); }
        public override double GetVy() { throw new Exception("Invalid coeficient wanted."); }
        public override double GetVz() { throw new Exception("Invalid coeficient wanted."); }



        public override void SetA(double value) { throw new Exception("Invalid coeficient setting."); }
        public override void SetB(double value) { throw new Exception("Invalid coeficient setting."); }
        public override void SetC(double value) { throw new Exception("Invalid coeficient setting."); }
        public override void SetP(double value) { throw new Exception("Invalid coeficient setting."); }

        //public override void SetM(double value) { _values[3] = value; }
        //public override void SetN(double value) { _values[4] = value; }
        //public override void SetO(double value) { _values[5] = value; }

        public override void SetUx(double value) { _values[0] = value; }
        public override void SetUy(double value) { _values[1] = value; }
        public override void SetUz(double value) { _values[2] = value; }
        public override void SetVx(double value) { throw new Exception("Invalid coeficient setting."); }
        public override void SetVy(double value) { throw new Exception("Invalid coeficient setting."); }
        public override void SetVz(double value) { throw new Exception("Invalid coeficient setting."); }
    }
}
