﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Geometry.GraphicObjects.Equations
{
    public class QuadricParametricEquation:ParametricEquation
    {

        public QuadricParametricEquation(QuadricParametricEquation src) 
        {
            _values = base.CopyValues(src);
        }

        public QuadricParametricEquation(double A, double B, double C, double P)
        {
            _values = new List<double>() { A, B, C, P };
        }

        public static bool AreSame(QuadricParametricEquation a, QuadricParametricEquation b) 
        {
            QuadricParametricEquation c1 = new QuadricParametricEquation(a);
            QuadricParametricEquation c2 = new QuadricParametricEquation(b);
            bool found = false;
            for (int i = 0; i < c1._values.Count; i++) 
            {
                found = false;
                for (int j = 0; j < c2._values.Count; j++) 
                {
                    if (Program.IsEqualInTolerance(c1._values[i], c2._values[j]))
                    {
                        c2._values[j] = double.MaxValue;
                        found = true;
                        break;
                    }
                }
                if (!found)
                    return false;
            }
            return true;
        }

        public override double GetA() { return _values[0]; }
        public override double GetB() { return _values[1]; }
        public override double GetC() { return _values[2]; }
        public override double GetP() { return _values[3]; }


        public override double GetUx() { throw new Exception("Invalid coeficient wanted."); }
        public override double GetUy() { throw new Exception("Invalid coeficient wanted."); }
        public override double GetUz() { throw new Exception("Invalid coeficient wanted."); }
        public override double GetVx() { throw new Exception("Invalid coeficient wanted."); }
        public override double GetVy() { throw new Exception("Invalid coeficient wanted."); }
        public override double GetVz() { throw new Exception("Invalid coeficient wanted."); }

        public override void SetA(double value) { _values[0] = value; }
        public override void SetB(double value) { _values[1] = value; }
        public override void SetC(double value) { _values[2] = value; }
        public override void SetP(double value) { _values[3] = value; }


        public override void SetUx(double value) { throw new Exception("Invalid coeficient setting."); }
        public override void SetUy(double value) { throw new Exception("Invalid coeficient setting."); }
        public override void SetUz(double value) { throw new Exception("Invalid coeficient setting."); }
        public override void SetVx(double value) { throw new Exception("Invalid coeficient setting."); }
        public override void SetVy(double value) { throw new Exception("Invalid coeficient setting."); }
        public override void SetVz(double value) { throw new Exception("Invalid coeficient setting."); }
    }
}
