﻿using Geometry.GraphicObjects.Matrixes; 
using Geometry.GraphicObjects.Equations;
using Geometry.BaseClasses;
using GMath;

namespace Geometry.GraphicObjects.Quadrics
{
    /// <summary>
    /// x*x/a*a +1 =0;
    /// </summary>
    public class ImaginarParallelPlans : Quadric
    {
        private double _a;
        public static string canonicFormatString = "E[x-!m;!a]L[=-1]";
        public static string parametricXFormatString = "L[x = " + U.EmptySet + "]";
        public static string parametricYFormatString = "L[y = " + U.EmptySet + "]";
        public static string parametricZFormatString = "L[z = " + U.EmptySet + "]";
        public static string _wordDescriptionFirstCase = "Imaginární rovnoběžné roviny";
        public static string _wordDescriptionSecondCase = "Imaginárních rovnoběžných rovin";
        public static string _wordDescriptionFourthCase = "Imaginární rovnoběžné roviny";

        public ImaginarParallelPlans(CommonEquation commonEquation, ParametricEquation parametricEquation,
            TransformationMatrix toCanonicTransformationMatrix,
            GColor color, string name, int ID)
            : base(commonEquation, parametricEquation, toCanonicTransformationMatrix,
                        color, name,
                        _wordDescriptionFirstCase, _wordDescriptionSecondCase, _wordDescriptionFourthCase,
                        canonicFormatString,
                        parametricXFormatString, parametricYFormatString, parametricZFormatString, ID) 
        {
            _a = parametricEquation.GetA();
        }

        protected override void BuildParametricDisplayList(Scene scene, RelativeQuality relativeQuality)
        {

        }

        protected override Quadric CallConstructor(CommonEquation commonEquation, ParametricEquation parametricEquation,
            TransformationMatrix toCanonicTransformationMatrix, GColor color, string name, int ID)
        {
            return new ImaginarParallelPlans(commonEquation, parametricEquation, toCanonicTransformationMatrix, color, name, ID);
        }

        public override QuadricMatrix GetCanonicMatrix(QuadricParametricEquation parametricEquation)
        {
            double A = -1 / (parametricEquation.GetA() * parametricEquation.GetA());
            QuadricEquation newCanonicEquation = new QuadricEquation(A, 0, 0, 0, 0, 0, 0, 0, 0, -1);
            return new QuadricMatrix(newCanonicEquation);
        }
    }
}
