﻿using Geometry.GGraphic.Forms.Detail.FormatString;
using GMath; 

namespace Geometry.GraphicObjects
{
    public class WithCanonicEquationObject:WithCommonEquationObject
    {
        protected CanonicEquationFormatString _canonicEquationFormatString;
        protected int _normalSign = 1;


        public WithCanonicEquationObject()
        {
        }


        public CanonicEquationFormatString GetCanonicEquationFormatString() 
        { 
            return _canonicEquationFormatString; 
        }
        protected int GetNormalSign(Matrix rotation)
        {
            double determinant = rotation.Determinant4();
            if (determinant > 0)
                return 1;
            else return -1;
        }



        public CenterParametrization GetCenterInCanonicBasis()
        {
            return ConvertStandardToCanonicBasis(GetCenterInStandardBasis());
        }
        public CenterParametrization ConvertCanonicToStandardBasis(CenterParametrization centerInCanonicBasis)
        {
            return centerInCanonicBasis * base._transformationAlgebraic.ComputeInverseMatrix(); 
        }
        public CenterParametrization ConvertStandardToCanonicBasis(CenterParametrization centerInStandardBasis) 
        {
            return centerInStandardBasis * base._transformationAlgebraic;
        }



        protected TransformationMatrix GetToCanonicTransformationMatrix(
            TransformationMatrix oldToCanonicTransformationMatrix, CenterParametrization newCenter) 
        {
            TransformationMatrix copy = new TransformationMatrix(oldToCanonicTransformationMatrix);
            Vector center = newCenter.GetReprezentant();
            copy.SetTranslation(center);
            return copy;
        }


        public TransformationMatrix GetToCanonicTransformationMatrix() { return _transformationOpenGL; }
    }
}
