﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Geometry.GraphicObjects.Equations;
using Geometry.GGraphic.Forms.Detail.FormatString; 

namespace Geometry.GraphicObjects
{
    public class WithCommonEquationObject:WithParametricEquationObject
    {
        protected CommonEquation _commonEquation;
        protected CommonEquationFormatString _commonEquationFormatSring;

        public WithCommonEquationObject() 
        {
        }


        public CommonEquation GetCommonEquation() { return _commonEquation; }
        public CommonEquationFormatString GetCommonEquationFormatString() { return _commonEquationFormatSring; }
        
        /// <summary>
        /// Podělí equation nejmenším členem.
        /// </summary>
        protected CommonEquation NormalizeEquation(CommonEquation equation)
        {
            return equation.Normalize();
        }
        
        
        
        public virtual WithCommonEquationObject MakeCopyOfObject(CommonEquation commonEquation, int ID)
        {
            throw new Exception("Tato metoda musí být přepsána v potomkovi.");  
        }

        public override bool AreEqual(GraphicObject secondObject)
        {
            double koeficient = 0;
            CommonEquation firstObjectEquation = this._commonEquation;
            CommonEquation secondObjectEquation = ((WithCommonEquationObject)secondObject)._commonEquation;

            for (int i = 0; i < firstObjectEquation.GetMembersCount(); i++)
            {
                if (!Program.IsEqualInTolerance(firstObjectEquation.Get(i), 0))
                {
                    koeficient = secondObjectEquation.Get(i) / firstObjectEquation.Get(i);
                    break;
                }
            }
            for (int i = 0; i < firstObjectEquation.GetMembersCount(); i++)
            {
                if (!Program.IsEqualInToleranceLow(firstObjectEquation.Get(i)*koeficient, secondObjectEquation.Get(i)))
                    return false;
            }
            return true;
        }
    }
}
