﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Geometry
{
    public class CombinedHistoryItem:IHistoryItem
    {
        private List<HistoryItem> _historyItems;

        public CombinedHistoryItem(List<HistoryItem> historyItems, HistoryOperation historyOperation)
            :base(historyOperation)
        {
            _historyItems = historyItems;
        }


        public List<HistoryItem> GetHistoryItems()
        {
            return _historyItems;
        }

        public override IHistoryItem GetInverseHistoryItem()
        {
            List<HistoryItem> InverseHistoryItems = new List<HistoryItem>();
            foreach (HistoryItem historyItem in _historyItems) 
            {
                InverseHistoryItems.Add((HistoryItem)historyItem.GetInverseHistoryItem());
            }
            return new CombinedHistoryItem(InverseHistoryItems, GetInverseHistoryOperation());
        }

    }
}
