﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using Geometry.GraphicObjects;

namespace Geometry
{
    public class HistoryItem:IHistoryItem
    {
        public static int NOTaObject = -1; 
        private int _subjectID;
        private object _oldValue;
        private object _newValue;

        public HistoryItem(int subjectID, HistoryOperation historyOperation, object oldValue, object newValue)
            :base(historyOperation)
        {
            _subjectID = subjectID;
            _oldValue = oldValue;
            _newValue = newValue;
        }



        public object GetOldValue() 
        {
            return _oldValue;
        }        
        public object GetNewValue() 
        {
            return _newValue;
        }
        public int GetSubjectID() 
        {
            return _subjectID;
        }


        public override IHistoryItem GetInverseHistoryItem() 
        {
            return new HistoryItem(_subjectID, GetInverseHistoryOperation(), _newValue, _oldValue);
        }
    }
}
