﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Geometry
{
    public class IHistoryItem
    {
        private HistoryOperation _historyOperation;
        private static List<HistoryOperationPair> _pairs = new List<HistoryOperationPair>() 
        {
            new HistoryOperationPair(HistoryOperation.AddObject, HistoryOperation.DeleteObject),
            new HistoryOperationPair(HistoryOperation.DeleteObject, HistoryOperation.UnDeleteObject),
            new HistoryOperationPair(HistoryOperation.UnDeleteObject, HistoryOperation.DeleteObject),
            new HistoryOperationPair(HistoryOperation.ChangeObject, HistoryOperation.SwitchObjects),
            new HistoryOperationPair(HistoryOperation.SwitchObjects, HistoryOperation.SwitchObjects),
            new HistoryOperationPair(HistoryOperation.ChangeColor, HistoryOperation.ChangeColor),
            new HistoryOperationPair(HistoryOperation.ChangeName, HistoryOperation.ChangeName),
            new HistoryOperationPair(HistoryOperation.ChangeObjectAxesVisibility, HistoryOperation.ChangeObjectAxesVisibility),
            new HistoryOperationPair(HistoryOperation.ChangeObjectVisibility, HistoryOperation.ChangeObjectVisibility)
        };

        public IHistoryItem(HistoryOperation historyOperation) 
        {
            _historyOperation = historyOperation;
        }

        public HistoryOperation GetHistoryOperation()
        {
            return _historyOperation;
        }
        public HistoryOperation GetInverseHistoryOperation()
        {
            foreach (HistoryOperationPair pair in IHistoryItem._pairs)
                if (pair.historyOperation == _historyOperation)
                    return pair.inverseHistoryOperation;
            throw new Exception("Chyba");
        }

        public virtual IHistoryItem GetInverseHistoryItem() 
        {
            throw new Exception("Tato metoda musí být přepsána v potomkovi.");
        }
    }
}
